<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

if(isset($_SERVER['HTTP_ACCEPT'])) { 
	define('ACCEPT', $_SERVER['HTTP_ACCEPT']);
} else { 
	define('ACCEPT', "");
}

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
// message parts
// removes white space before and after each field value: trim()
$from	= (isset($_REQUEST['from']))	? $_REQUEST['from']			: -1;
$to 	= (isset($_REQUEST['to']))		? trim($_REQUEST['to'])		: "";
$cc 	= (isset($_REQUEST['cc']))		? trim($_REQUEST['cc'])		: "";
$bcc 	= (isset($_REQUEST['bcc']))		? trim($_REQUEST['bcc'])	: "";
$subj	= (isset($_REQUEST['subj']))	? trim($_REQUEST['subj'])	: "";
$body 	= (isset($_REQUEST['body']))	? trim($_REQUEST['body'])	: "";
$attach = (isset($_REQUEST['attach']))	? $_REQUEST['attach']		: "";
// is this a draft?
$draft	= (isset($_REQUEST['draft']))	? $_REQUEST['draft']		: false;
// include original message in reply?
$inc_orig =(isset($_REQUEST['inc_orig']))? $_REQUEST['inc_orig']		: false;
// include signature?
$sign	= (isset($_REQUEST['sign']))	? $_REQUEST['sign']			: false;
$fwd	= (isset($_REQUEST['fwd']))		? $_REQUEST['fwd']			: false;

// message parts in replies
$thread_id 	= (isset($_REQUEST['th']))	? $_REQUEST['th']			: "";
$msg_id 	= (isset($_REQUEST['mg']))	? $_REQUEST['mg']			: "";

// action control variables
$action = (isset($_REQUEST['action']))	? $_REQUEST['action']		: "";

if ($draft == 1) {
	$_SESSION['gm_back'] = code_url("main.php?std=drafts","encode");
} elseif (isset($_REQUEST['back'])) {
	$_SESSION['gm_back'] = $_REQUEST['back'];
} elseif (!isset($_SESSION['gm_back'])) {
	$_SESSION['gm_back'] = code_url('main.php',"encode");
}

// initialize the status message returned after an action is performed
$status_message = "";

// for replies only
// limit to the number of addresses that can be used in the
// cc field when doing a "reply to all"
// This is to prevent a field from overflowing with two much data
// and crashing the phone when trying to edit the field
$max_cc_reply_to_all = 15;
$reply_to_all = (isset($_REQUEST['all'])) ? $_REQUEST['all'] : 0;

// contact (address book) related
// "just came from selecting contacts"
$contacts_selected = (isset($_REQUEST['sel'])) ? true : false;

if ($action == "reply1") {

	$_SESSION['gm_reply_th'] = $thread_id;
	$_SESSION['gm_reply_mg'] = $msg_id;

	// retrieve the message and cache it
	$gmailer->fetchBox(GM_CONVERSATION, array($thread_id,$msg_id), 0);
	$snapshot = $gmailer->getSnapshot(GM_CONVERSATION);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	$_SESSION['gm_reply_message'] = $snapshot;

	//debug_print("Reply message: ".print_r($_SESSION['gm_reply_message'],true));
	//debug_print("Reply thread: ".print_r($_SESSION['gm_reply_message'],true));

	reply_options($_SESSION['gm_reply_message']);
	
	exit;
	
} elseif ($action == "discard") {
	$back = str_replace(" ","+",code_url($_SESSION['gm_back'],"decode"));

	// actual redirection
	redirect_page($back, $gm_lang['discard'], $gm_lang['discarding_msg']);	

	// unset relevant session variables
	unset($_SESSION['gm_all_to']);
	unset($_SESSION['gm_all_cc']);
	unset($_SESSION['gm_all_bcc']);
	unset($_SESSION['gm_subject']);
	unset($_SESSION['gm_message']);
	unset($_SESSION['gm_contacts_all']);
	unset($_SESSION['gm_contacts_freq']);
	unset($_SESSION['gm_contacts_group']);
	unset($_SESSION['gm_contacts_index']);
	unset($_SESSION['gm_msg_id']);
	unset($_SESSION['gm_thread_id']);
	unset($_SESSION['gm_back']);
	unset($_SESSION['gm_is_draft']);
	unset($_SESSION['gm_draft_msg_id']);
	unset($_SESSION['gm_include_orig']);
	unset($_SESSION['gm_include_orig_msg']);
	unset($_SESSION['gm_forward']);
	unset($_SESSION['gm_use_sign']);
	unset($_SESSION['gm_from_address']);
	unset($_SESSION['gm_uploaded_attach']);
	unset($_SESSION['gm_uploaded_attach_array']);
	$_SESSION['gm_to_index'] = array();
	$_SESSION['gm_cc_index'] = array();
	$_SESSION['gm_bcc_index'] = array();
	if (isset($_SESSION['gm_reply_th'])) unset($_SESSION['gm_reply_th']);
	if (isset($_SESSION['gm_reply_mg'])) unset($_SESSION['gm_reply_mg']);
	if (isset($_SESSION['gm_reply_message'])) unset($_SESSION['gm_reply_message']);
	unset($_SESSION['gm_attach_filename']);
	if (isset($_SESSION['gm_attach_dir'])) rmdirr($conf['temp_dir'].$_SESSION['gm_attach_dir']);
	unset($_SESSION['gm_attach_dir']);


	exit;
}

if (($action == "send" or $action == "save")) {

	// save the fields in case there is a send error
	$_SESSION['gm_all_to'] = htmlspecialchars($to);
	$_SESSION['gm_all_cc'] = htmlspecialchars($cc);
	$_SESSION['gm_all_bcc'] = htmlspecialchars($bcc);
	$_SESSION['gm_subject'] = htmlspecialchars($subj);
	$_SESSION['gm_message'] = htmlspecialchars($body);
	$_SESSION['gm_uploaded_attach'] = $attach;
	$_SESSION['gm_from_address'] = $from;
	$_SESSION['gm_use_sign'] = $sign;

	if (	($action == "send")
		and (!(strlen($_SESSION['gm_all_to'])  > 0))
		and (!(count($_SESSION['gm_to_index']) > 0))
		and (!(strlen($_SESSION['gm_all_cc'])  > 0))
		and (!(count($_SESSION['gm_cc_index']) > 0))
		and (!(strlen($_SESSION['gm_all_bcc']) > 0))
		and (!(count($_SESSION['gm_bcc_index']) > 0))
	) {
		// if sending, and no contacts selected or entered, display error
		$status_message = $gm_lang['specify_recipient'];

	} elseif (trim($body) == "" and $_SESSION['gm_include_orig_msg'] == ""){
		// if the message text is empty
		$status_message = $gm_lang['msg_no_text'];

	} elseif (trim($subj) == ""){
		// if the subject is empty
		$status_message = $gm_lang['pls_give_subject'];

	} else {
		// enough to send mail

		// contact.php has set three $_SESSION arrays: to_index, cc_index, and bcc_index
		// Each array is comprised of index values corresponding to the addressbook
		
		//debug_print("all contacts:".print_r($_SESSION['gm_contacts_all']->contacts,true));

		// $_SESSION['gm_contacts_all'] was set only if the Contacts were used in composing mail
		if (isset($_SESSION['gm_contacts_all']->contacts)) {
			$contacts = $_SESSION['gm_contacts_all']->contacts;
			foreach(array("to","cc","bcc") as $temp) {
				foreach ($_SESSION["gm_${temp}_index"] as $indexval => $con_id) {
					$index = $_SESSION['gm_contacts_index'][$con_id];
					if (${$temp} == "") ${$temp} = $contacts[$index]['email'];
					else ${$temp} .= ", ".$contacts[$index]['email'];
				}
			}
		}

		$to = html_entity_decode($to);
		$cc = html_entity_decode($cc);
		$bcc = html_entity_decode($bcc);
		$subj = html_entity_decode($subj);
		
		// uploaded/forwarded attachments
		$uploaded_attach = array();
		if ($attach != "" and (count($_SESSION['gm_uploaded_attach_array']) > 0)) {
			$attach_these = explode(";",$attach);
			$count_attach_these = count($attach_these);
			for ($a = 0; $a < $count_attach_these; $a++) {
				if ($attach_these[$a] == "") continue;
				$b = $attach_these[$a]+0;
				$uploaded_attach[] = "0_".$_SESSION['gm_msg_id']."_"
					.$_SESSION['gm_uploaded_attach_array'][$b]['id'];
			}
		
/* 			debug_print("forwarded attachments:: attach: ".print_r($attach,true) */
/* 				."\n exploded attach: ".print_r($attach_these,true) */
/* 				."\n all attachments: ".print_r($_SESSION['gm_uploaded_attach_array'],true) */
/* 				."\n ids: ".print_r($uploaded_attach,true) */
/* 				); */
		}

		// FROM address
		if ($from == "") {
			// do nothing, use default
			// this "if" NEEDS to be here so it's not caught by another condition 
		} elseif ($from == -1) {
			// gmail account
			$from = "";
		} elseif (($from >= 0) and (isset($_SESSION['gm_from_addresses'][$from]['email']))) {
			// an alternate
			$from = $_SESSION['gm_from_addresses'][$from]['email'];
		} else {
			// something wrong, use default
			$from = "";
		}
		
		// attach the original message, signature, etc
		$body = str_replace("\\n","\r\n",$body);
		if ($_SESSION['gm_use_sign']) $body .= $_SESSION['gm_signature'];
		$body .= $_SESSION['gm_include_orig_msg'];
		
		
		if ($action == "save") {
			// save draft
			$save_draft = true;
		} else {
			// send message
			$save_draft = false;
		}
	
		// bool send(string to, string subject, string body, string cc, string bcc, 
		//     string message_replying, string thread_replying, array attachments, 
		//     bool draft_saving, string draft_id,
		//     bool is_html, string from email id)
		// e.g. $gmailer->send($to, $subj, $body, $cc, $bcc, $msg_id, $thread_id, $fname, true, $msg_id, 0, $from, $preloaded_attachments);
		$status 		= $gmailer->send($to, $subj, $body, $cc, $bcc, 
							$_SESSION['gm_msg_id'], $_SESSION['gm_thread_id'], 
							$_SESSION['gm_attach_filename'], 
							$save_draft, $_SESSION['gm_draft_msg_id'],
							0 /* is_html */,$from, $uploaded_attach);
		$status_message	= $gmailer->lastActionStatus('message');
		$threadid		= $gmailer->lastActionStatus('thread_id');
		$num_recipients	= $gmailer->lastActionStatus('sent_num');

		if ($status) {

			// delete the attachments
			rmdirr($conf['temp_dir'].$_SESSION['gm_attach_dir']);

/* 			$num_recipients	= ""; */
/* 			if ($num_recipients == 1) { */
/* 				$num_recipients = " -- ".$num_recipients." ".$gm_lang['recipient']; */
/* 			} else { */
				$num_recipients = " -- ".$num_recipients." ".$gm_lang['recipients'];
/* 			} */

			$url = "main.php?th=".$threadid;
	
			// redirect
			if ($action == "save") {
				$title = $gm_lang['saving_draft'];
				$message = "<em>$status_message</em>";
			} else {
				$title = $gm_lang['sending_message'];
				$message = "<em>$status_message</em>".$num_recipients;
			}
	
			// actual redirection
			redirect_page($url, $title, $message, 30);	
	
			// do NOT unset relevent session variables, in case someone
			//     comes "back" -- it turns out to be disastrous!
			// Attachments will already have been deleted, but, oh well!
		
			exit;
			
		} 
	}

} elseif ($thread_id || $msg_id || ($action == "reply2")) {

	$_SESSION['gm_msg_cache_id']	= "";
	$_SESSION['gm_thread_cache_id']	= "";
	$_SESSION['gm_is_draft'] = $draft;
	$_SESSION['gm_forward']  = $fwd;
	
	if ($_SESSION['gm_is_draft']) {
		$gmailer->fetchBox(GM_CONVERSATION, $thread_id, 0);
		$ss = $gmailer->getSnapshot(GM_CONVERSATION);
		if ($ss->created == 0) static_error($ss->snapshot_error);

		//debug_print(print_r($ss,true));
		$found_the_draft = false;
		$count_conversations = count($ss->conv);
		for ($i = 0; $i < $count_conversations; $i++) {
		  if ($ss->conv[$i]['is_draft'] == true && $ss->conv[$i]['draft_parent'] == $msg_id) {
			 $the_draft = $ss->conv[$i];
			 $found_the_draft = true;
			 break;
		  }
		}
		
		if (!$found_the_draft) {
			debug_print(basename(__FILE__).": ".__LINE__.", draft not found error.  Error message displayed.");
			msg_not_found("Message not found.  Please report to the developer at gmobile@sayni.net to help improve gmail-mobile.");
		}
		//debug_print(print_r($the_draft,true));
	} elseif ($_SESSION['gm_forward']) {
		// setup compose screen as a forward to a message
		
		// retrieve and cache the message
		$gmailer->fetchBox(GM_CONVERSATION, array($thread_id,$msg_id), 0);
		$snapshot = $gmailer->getSnapshot(GM_CONVERSATION);
		if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
		$_SESSION['gm_reply_message'] = $snapshot;

		// retrieve cached message
		$ss = $_SESSION['gm_reply_message'];
		
	} else {
		// setup compose screen as a reply to a message

		// retrieve cached message
		$ss = $_SESSION['gm_reply_message'];
	}
	
	//debug_print(print_r($ss,true));
	
	///////////////////
	//
	// TO
	//
	$to_limit = false;
	$to = "";
	if ($_SESSION['gm_is_draft']) {
		if (!is_array($the_draft['recv_email'])) {
			//debug_print(__FILE__." ".__LINE__.": not an array: dump message: ".print_r($the_draft,true));
		}
		foreach ($the_draft['recv_email'] as $indexval => $emailaddress) {
			$to .= ($to == "") ? $emailaddress : ", $emailaddress" ;
		}
	} elseif ($_SESSION['gm_forward']) {
		// nothing
	} else {
		$to_count = 0;
		if (count($ss->conv[0]['reply_email']) == 0) {
			// no "reply to" address, use sender
			$to = $ss->conv[0]['sender_email'];
			$to_count = 1;
		} else {
			// reply to address(es) exist, flatten the array
			// implode doesn't always work, use foreach
			foreach ($ss->conv[0]['reply_email'] as $indexval => $emailaddress) {
				if ($to == "") $to = $emailaddress;
				else $to .= ", $emailaddress";
			}
			$to_count = count($ss->conv[0]['reply_email']);
		}
		if ($reply_to_all == 2) {
			$total_to = $to_count + count($ss->conv[0]['recv_email']);
			// flatten the array
			// do not use implode because we want to limit the number
			if ($total_to > $max_cc_reply_to_all) $to_limit = true;
			for ($i=0;$to_count<=$max_cc_reply_to_all;$i++, $to_count++) {
				if (!isset($ss->conv[0]['recv_email'][$i])) break;
				if ($to == "") $to = $ss->conv[0]['recv_email'][$i];
				else $to .= ", ".$ss->conv[0]['recv_email'][$i];
			}
		}
	}
	$to = htmlspecialchars($to);
	$_SESSION['gm_all_to'] = $to;
	//
	///////////////////

	///////////////////
	//
	// CC
	//
	$cc_limit = false;
	if ($_SESSION['gm_is_draft']) {
		$cc = "";
		if (!is_array($the_draft['cc_email'])) {
			//debug_print(__FILE__." ".__LINE__.": not an array: dump message: ".print_r($the_draft,true));
		}
		foreach ($the_draft['cc_email'] as $indexval => $emailaddress) {
			$cc .= ($cc == "") ? $emailaddress : ", $emailaddress" ;
		}
	} elseif ($_SESSION['gm_forward']) {
			$cc = "";
	} else {
		$cc = "";
		if ($reply_to_all == 1) {
			// flatten the array
			// do not use implode because we want to limit the number
			for ($i=0;$i<$max_cc_reply_to_all;$i++) {
				if (!isset($ss->conv[0]['recv_email'][$i])) break;
				if ($cc == "") $cc = $ss->conv[0]['recv_email'][$i];
				else $cc .= ", ".$ss->conv[0]['recv_email'][$i];
			}
			$total_cc = count($ss->conv[0]['recv_email']);
			if ($total_cc > $max_cc_reply_to_all) $cc_limit = true;
			$cc = htmlspecialchars($cc);
		} elseif ($reply_to_all == 2) {
			// flatten the array
			// do not use implode because we want to limit the number
			for ($i=0;$i<$max_cc_reply_to_all;$i++) {
				if (!isset($ss->conv[0]['cc_email'][$i])) break;
				if ($cc == "") $cc = $ss->conv[0]['cc_email'][$i];
				else $cc .= ", ".$ss->conv[0]['cc_email'][$i];
			}
			$total_cc = count($ss->conv[0]['cc_email']);
			if ($total_cc > $max_cc_reply_to_all) $cc_limit = true;
			$cc = htmlspecialchars($cc);
		}
	}
	$_SESSION['gm_all_cc'] = $cc;
	//
	///////////////////

	///////////////////
	//
	// BCC
	//
	if ($_SESSION['gm_is_draft']) {
		$bcc = "";
		if (!is_array($the_draft['bcc_email'])) {
			//debug_print(__FILE__." ".__LINE__.": not an array: dump message: ".print_r($the_draft,true));
		}
		foreach ($the_draft['bcc_email'] as $indexval => $emailaddress) {
			$bcc .= ($bcc == "") ? $emailaddress : ", $emailaddress" ;
		}
		$_SESSION['gm_all_bcc'] = htmlspecialchars($bcc);
	} elseif ($_SESSION['gm_forward']) {
		$_SESSION['gm_all_bcc'] = "";
	} else {
		$_SESSION['gm_all_bcc'] = "";
	}
	//
	///////////////////
	
	///////////////////
	//
	// Subject
	//
	if ($_SESSION['gm_is_draft']) {
		$subj = $the_draft['subj'];
	} elseif ($_SESSION['gm_forward']) {
		if (!isset($ss->conv)) {		
			// msg not found, redirect to last mailbox
			msg_not_found($ss->snapshot_error);
			exit;

		} else {
			$subj = $ss->conv[0]['subj'];
		}
		// remove fwd:'s and re:'s from subject
		$subj = trim(preg_replace('/^\s*(('.$gm_lang['fwd_lower'].'|fwd:|fw:|'.$gm_lang['re_lower'].'|re:)\s*)+/is', '', $subj)); 
		// add Fwd:
		$subj = $gm_lang['fwd_col']." ".$subj;

	} else {
		// remove fwd:'s and re:'s from subject
		$subj = trim(preg_replace('/^\s*(('.$gm_lang['fwd_lower'].'|fwd:|fw:|'.$gm_lang['re_lower'].'|re:)\s*)+/is', '', $ss->conv[0]['subj'])); 
		// add Re:
		$subj = $gm_lang['re_cap']." ".$subj;

	}
	$subj = htmlspecialchars($subj);
	$_SESSION['gm_subject'] = $subj;
	//
	///////////////////

	///////////////////
	//
	// body
	//
	$_SESSION['gm_use_sign'] = $_SESSION['gm_setting_gen_cache']['use_signature'];
	$_SESSION['gm_include_orig'] = $inc_orig;
	//$newline = "\r\n";
	$newline = "\n";
	$orig_text = "";

	if ($_SESSION['gm_is_draft']) {
		$_SESSION['gm_include_orig_msg'] = "";
		$_SESSION['gm_message'] = htmlspecialchars($the_draft['body']);
		$_SESSION['gm_use_sign'] = 0;

	} elseif ($_SESSION['gm_forward']) {

		// include the original message
		$orig_text .= $newline.$newline;
		$orig_text .= "---------- ".$gm_lang['forwarded_message']." ----------".$newline;
		// from
		$orig_text .= $gm_lang['from']." ".$ss->conv[0]['sender']." <".$ss->conv[0]['sender_email'].">".$newline;
		// date
		$orig_text .= $gm_lang['date']." ".$ss->conv[0]['dt'].$newline;
		// subject
		$orig_text .= $gm_lang['subject']." ".$ss->conv[0]['subj'].$newline;
		// to
		if (count($ss->conv[0]['recv_email']) > 0) {
			if (count($ss->conv[0]['recv_email']) == 1) {
				// if only one recipient, try to make it nice: name <email@email.com>
/* 				if ($ss->conv[0]['recv'] == "") { */
					$orig_text .= $gm_lang['to']." ".$ss->conv[0]['recv_email'][0].$newline;
/* 				} else { */
/* 					$orig_text .= $gm_lang['to']." \"".$ss->conv[0]['recv']."\" <".$ss->conv[0]['recv_email'][0].">".$newline; */
/* 				} */
			} else {
				// more than one recipient, flatten the array
				$temp_to = "";
				$count_recv_email = count($ss->conv[0]['recv_email']);
				for ($i=0; $i < $count_recv_email; $i++) {
					$temp_to .= ($temp_to == "") ? $ss->conv[0]['recv_email'][$i] : ", ".$ss->conv[0]['recv_email'][$i] ;
				}
				$orig_text .= $gm_lang['to']." ".$temp_to.$newline;
			}
		} else {
			$orig_text .= $gm_lang['unnamed_recipients']." ".$newline;
		}

		$orig_text .= $newline;

		// now add the actual text
		//$orig_text .= str_replace(array("<br />\n","<br />"), array($newline."> ",$newline."> "), un_htmlspecialchars(sanitize_body($ss->conv[0]['body'])));
		$orig_text .= str_replace(array("<br />\n","<br />"), array($newline,$newline), un_htmlspecialchars(sanitize_body($ss->conv[0]['body'])));

		// save it
		$_SESSION['gm_include_orig_msg'] = $orig_text;
		$_SESSION['gm_message'] = "";

	} elseif ($_SESSION['gm_include_orig']) {
		// include the original message
		// add the On xxx, yyy wrote:
		$orig_text .= $newline.$newline.$ss->conv[0]['quote_str'].$newline."> ";
		// now add the actual text and quote it
		$orig_text .= str_replace(array("<br />\n","<br />"), array($newline."> ",$newline."> "), un_htmlspecialchars(sanitize_body($ss->conv[0]['body'])));
		//debug_print("orig body: ".$ss->conv[0]['body']);
		//debug_print("sanitized body: ".sanitize_body($ss->conv[0]['body']));
		//debug_print("sanitized/unhtml body: ".un_htmlspecialchars(sanitize_body($ss->conv[0]['body'])));
		//debug_print("full forwarded body: ".$orig_text);

		// save it
		$_SESSION['gm_include_orig_msg'] = $orig_text;
		$_SESSION['gm_message'] = "";

	} else {
		$_SESSION['gm_include_orig_msg'] = $orig_text;
		$_SESSION['gm_message'] = "";

	}
	//
	///////////////////

	///////////////////
	//
	// Attachments
	//

	$_SESSION['gm_attach_filename']	= array();
	$_SESSION['gm_attach_dir'] 		= $msg_id;
	
	if ($_SESSION['gm_is_draft']) {
		$_SESSION['gm_uploaded_attach_array'] = array();
		$_SESSION['gm_uploaded_attach']	= "";
	} elseif ($_SESSION['gm_forward']) {
		$_SESSION['gm_uploaded_attach_array'] = $ss->conv[0]['attachment'];
		$attach = "";
		$uploaded_num = count($_SESSION['gm_uploaded_attach_array']);
		for ($up = 0; $up < $uploaded_num; $up++) {
			$attach .= ($attach != "") ? ";$up" : "$up";
		}
		$_SESSION['gm_uploaded_attach']	= $attach;

	} else {
		$_SESSION['gm_uploaded_attach_array'] = array();
		$_SESSION['gm_uploaded_attach']	= "";
	}
	//
	///////////////////


	///////////////////
	//
	// From
	//
	$_SESSION['gm_from_address'] = -1;
	$person_count = count($_SESSION['gm_from_addresses']);

	if ($_SESSION['gm_is_draft']) {
		for($i = 0; $i < $person_count; $i++) {
			if ($_SESSION['gm_from_addresses'][$i]['email'] == $the_draft['sender_email']) {
				$_SESSION['gm_from_address'] = $i;
				break;
			}
		}
	} else {
		for($i = 0; $i < $person_count; $i++) {
			if ($_SESSION['gm_from_addresses'][$i]['default']) {
				$_SESSION['gm_from_address'] = $i;
				break;
			}
		}
	}
	//
	///////////////////


	///////////////////
	//
	// Other
	//
	if ($_SESSION['gm_is_draft']) {
		$_SESSION['gm_draft_msg_id'] = $the_draft['id'];
	} else {
		$_SESSION['gm_draft_msg_id'] = "";
	}
	$_SESSION['gm_msg_id']    = $msg_id;
	$_SESSION['gm_thread_id'] = $thread_id;
	$_SESSION['gm_to_index']  = array();
	$_SESSION['gm_cc_index']  = array();
	$_SESSION['gm_bcc_index'] = array();

	// clear old contacts cache
	unset($_SESSION['gm_contacts_all']);
	unset($_SESSION['gm_contacts_freq']);
	unset($_SESSION['gm_contacts_group']);
	unset($_SESSION['gm_contacts_index']);

	//
	///////////////////

	
	//debug_print(print_r($_SESSION,true));

} elseif ($contacts_selected) {
	// just came from selecting contacts

	// uses a cached object of contact addresses from contact.php

	// if no contacts are selected or already entered, display error
	if (
			(!strlen($_SESSION['gm_all_to'])   > 0)
		and (!count($_SESSION['gm_to_index'])  > 0)
		and (!strlen($_SESSION['gm_all_cc'])   > 0)
		and (!count($_SESSION['gm_cc_index'])  > 0)
		and (!strlen($_SESSION['gm_all_bcc'])  > 0)
		and (!count($_SESSION['gm_bcc_index']) > 0)
	) {
		$status_message = $gm_lang['specify_recipient'];
	}

} elseif ($action == "gocon") {
	// go to contacts
	
	// save fields first!
	$_SESSION['gm_subject'] = htmlspecialchars($subj);
	$_SESSION['gm_message']	= htmlspecialchars($body);
	$_SESSION['gm_all_to'] 	= htmlspecialchars($to);
	$_SESSION['gm_all_cc'] 	= htmlspecialchars($cc);
	$_SESSION['gm_all_bcc'] = htmlspecialchars($bcc);
	$_SESSION['gm_from_address'] = $from;
	$_SESSION['gm_uploaded_attach'] = $attach;
	$_SESSION['gm_use_sign'] = $sign;
	
	$url = "contact.php?sel=1";

	// actual redirection
	redirect_page($url, $gm_lang['select_contacts'], $gm_lang['setting_up_contacts']);	
	// redirect
	exit;

} elseif ($action == "attach") {
	// Attach a file
	
	// save fields first!
	$_SESSION['gm_subject'] = htmlspecialchars($subj);
	$_SESSION['gm_message']	= htmlspecialchars($body);
	$_SESSION['gm_all_to'] 	= htmlspecialchars($to);
	$_SESSION['gm_all_cc'] 	= htmlspecialchars($cc);
	$_SESSION['gm_all_bcc'] = htmlspecialchars($bcc);
	$_SESSION['gm_from_address'] = $from;
	$_SESSION['gm_uploaded_attach'] = $attach;
	$_SESSION['gm_use_sign'] = $sign;
	html_attach($conf['attach_up_limit']);
	
	exit;

} elseif ($action == "upload") {
	// file attachments

	//debug_print("upload array: ".print_r($_FILES,true));
	$tmpdir = $conf['temp_dir'].$_SESSION['gm_attach_dir'];

	// delete previous attachments if they exist
	rmdirr($tmpdir);
	$_SESSION['gm_attach_filename']	= array();

	for ($i = 1; $i <= $conf['attach_up_number']; $i++) {
		// attachment uploaded
		$filename 	= (isset($_FILES['attach'.$i]['name']))		? $_FILES['attach'.$i]['name'] 		: 0;
		$filesize 	= (isset($_FILES['attach'.$i]['size']))		? $_FILES['attach'.$i]['size'] 		: -1;
		$filetype 	= (isset($_FILES['attach'.$i]['type']))		? $_FILES['attach'.$i]['type'] 		: "";
		$filetmp 	= (isset($_FILES['attach'.$i]['tmp_name']))	? $_FILES['attach'.$i]['tmp_name'] 	: 0;
	
		$filename = str_replace(array("'"," ","/","$",":"), '_', stripslashes($filename));		
	
		if (is_uploaded_file($filetmp)) {
			if (file_exists($filetmp)) {
				if (!file_exists($tmpdir)) {
					mkdir($tmpdir);
					//chmod($tmpdir, 0777);
				}
				if (move_uploaded_file($filetmp, $tmpdir."/".$filename)) {
					$_SESSION['gm_attach_filename'][] = $tmpdir."/".$filename;
				} else {
					$status_message .= $gm_lang['upload_err_a'];
				}
			} else {
				$status_message .= $gm_lang['upload_err_b'];
			}
		} else {
			if (!(isset($_FILES['attach'.$i]['error']))) continue;
			switch($_FILES['attach'.$i]['error']) {
				case 0: //no error; possible file attack!
					$status_message .= $gm_lang['upload_err_0'];
					if (file_exists($filetmp)) unlink($filetmp);
					break;
				case 1: //uploaded file exceeds the upload_max_filesize directive in php.ini
					$status_message .= $gm_lang['upload_err_1'];
					if (file_exists($filetmp)) unlink($filetmp);
					break;
				case 2: //uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the html form
					$status_message .= sprintf($gm_lang['upload_err_2'],$conf['attach_up_limit']/1024);
					if (file_exists($filetmp)) unlink($filetmp);
					break;
				case 3: //uploaded file was only partially uploaded
					$status_message .= $gm_lang['upload_err_3'];
					if (file_exists($filetmp)) unlink($filetmp);
					break;
				case 4: //no file was uploaded
					//$status_message .= $gm_lang['upload_err_4'];
					//if (file_exists($filetmp)) unlink($filetmp);
					break;
				default: //a default error, just in case!	:)
					$status_message .= $gm_lang['upload_err_d'];
					if (file_exists($filetmp)) unlink($filetmp);
					break;
			}
		}
	}
	
	//debug_print("attachment array: ".print_r($_SESSION['gm_attach_filename'],true));
		
} elseif ($action == "new") {

	// fresh/new compose screen
	
	// clear old contacts cache
	unset($_SESSION['gm_contacts_all']);
	unset($_SESSION['gm_contacts_freq']);
	unset($_SESSION['gm_contacts_group']);
	unset($_SESSION['gm_contacts_index']);

	// set all message fields 
	$_SESSION['gm_all_to'] 		= "";
	$_SESSION['gm_all_cc'] 		= "";
	$_SESSION['gm_all_bcc'] 	= "";
	$_SESSION['gm_subject'] 	= "";
	$_SESSION['gm_message'] 	= "";
	$_SESSION['gm_msg_id'] 		= "";
	$_SESSION['gm_thread_id'] 	= "";
	$_SESSION['gm_is_draft'] 	= false;
	$_SESSION['gm_to_index']  	= array();
	$_SESSION['gm_cc_index']  	= array();
	$_SESSION['gm_bcc_index'] 	= array();
	$_SESSION['gm_forward'] 	= false;
	$_SESSION['gm_draft_msg_id'] = "";
	$_SESSION['gm_include_orig'] = false;
	$_SESSION['gm_use_sign']	= $_SESSION['gm_setting_gen_cache']['use_signature'];
	$_SESSION['gm_uploaded_attach'] = "";
	$_SESSION['gm_uploaded_attach_array'] = array();
	$_SESSION['gm_attach_filename']	= array();
	$_SESSION['gm_attach_dir'] 		= time()."_".str_rand(6);
	$_SESSION['gm_include_orig_msg'] = "";
	// no error
	$status_message = "";
	$_SESSION['gm_from_address'] = -1;
	$person_count = count($_SESSION['gm_from_addresses']);
	for($i = 0; $i < $person_count; $i++) {
		if ($_SESSION['gm_from_addresses'][$i]['default']) {
			$_SESSION['gm_from_address'] = $i;
			break;
		}
	}

} elseif ($action == "up_cancel") {
	// simply display the compose page again

} else {

}

// flag to determine if the cc field was truncated in a reply to all
$to_limit = (isset($to_limit)) ? $to_limit : false;
$cc_limit = (isset($cc_limit)) ? $cc_limit : false;

$to_addresses = "";
$cc_addresses = "";
$bcc_addresses = "";

/* debug_print(print_r($_SESSION['gm_to_index'],true)); */
/* debug_print(print_r($_SESSION['gm_cc_index'],true)); */
/* debug_print(print_r($_SESSION['gm_bcc_index'],true)); */
/* debug_print(print_r($_SESSION['gm_contacts_index'],true)); */

if (isset($_SESSION['gm_contacts_all']->contacts)) {
	$contacts = $_SESSION['gm_contacts_all']->contacts;
	foreach(array("to","cc","bcc") as $temp) {
		foreach ($_SESSION["gm_${temp}_index"] as $indexval => $con_id) {
			$index = $_SESSION['gm_contacts_index'][$con_id];
			$field = ($contacts[$index]['is_group']) ? "name" : "email";
			${$temp . "_addresses"} .= $contacts[$index]["$field"]."<br />\n";
		}
	}
}

print_headers();			// send wml headers
include("template.php");	// print template
?>
<card id="main" title="<? echo $gm_lang['compose_mail'] ?>">
<onevent type="onenterforward">
<refresh>
<setvar name="from" value="<? echo $_SESSION['gm_from_address'] ?>" />
<? 
if (!$thread_id and !$msg_id and !$contacts_selected and !($action == "send")) { ?>
<setvar name="to" value="" />
<setvar name="cc" value="" />
<setvar name="bcc" value="" />
<setvar name="subj" value="" />
<setvar name="body" value="" />
<? 
} else {
?>
<setvar name="to" value="<? echo $_SESSION['gm_all_to'] ?>" />
<setvar name="cc" value="<? echo $_SESSION['gm_all_cc'] ?>" />
<setvar name="bcc" value="<? echo $_SESSION['gm_all_bcc'] ?>" />
<setvar name="subj" value="<? echo $_SESSION['gm_subject'] ?>" />
<setvar name="body" value="<? echo $_SESSION['gm_message'] ?>" />
<?
}
if ($_SESSION['gm_uploaded_attach'] != "") {
	?><setvar name="attach" value="<? echo $_SESSION['gm_uploaded_attach'] ?>" />
<? }

if ($_SESSION['gm_setting_gen_cache']['use_signature']) {
	?><setvar name="sign" value="<? echo $_SESSION['gm_use_sign'] ?>" />
<? } ?>
</refresh>
</onevent>
<p>
<? 
// display a system-wide message
system_message();	

if ($status_message != "") echo "<em>$status_message</em><br /><br />\n"; 

echo $gm_lang['compose_mail'];
?><br />
<br />
<anchor title="<? echo $gm_lang['select_fr_contacts'] ?>"><go href="compose.php?action=gocon&amp;<? echo strip_tags(SID) ?>" method="post">
	<postfield name="subj" value="$(subj)" />
	<postfield name="body" value="$(body)" />
	<postfield name="to" value="$(to)" />
	<postfield name="cc" value="$(cc)" />
	<postfield name="bcc" value="$(bcc)" />
	<postfield name="from" value="$(from)" />
	<postfield name="attach" value="$(attach)" />
<? if ($_SESSION['gm_setting_gen_cache']['use_signature']) { ?>
	<postfield name="sign" value="$(sign)" />
<? } ?>
</go><? echo $gm_lang['select_fr_contacts'] ?></anchor>
<br />
<br />

<? echo $gm_lang['from'] ?><br />
<select title="<? echo $gm_lang['from'] ?>" name="from">
<?
	echo "<option value=\"-1\">".$_SESSION['gm_gmail_name']."</option>\n";
	$all_from = "";
	$person_count = count($_SESSION['gm_from_addresses']);
	for($i = 0; $i < $person_count; $i++) {
		$fromname = $_SESSION['gm_from_addresses'][$i]['name'];
		$fromemail = $_SESSION['gm_from_addresses'][$i]['email'];
		//echo "<option value=\"".$i."\">".cleanse_string($fromname)." &lt;".cleanse_string($fromemail)."&gt;</option>\n";
		$all_from .= "<option value=\"".$i."\">".cleanse_string($fromemail)."</option>\n";
	}	
	echo $all_from;
?>
</select>
<br />

<? echo $gm_lang['to'] ?><br />
<input name="to" title="<? echo $gm_lang['to'] ?>" format="*m" emptyok="true" />
<? if ($to_limit) echo "<small>".sprintf($gm_lang['only_first_x_kept'],$max_cc_reply_to_all,$total_to)."</small><br />\n"; ?>
<?
if (count($_SESSION['gm_to_index']) > 0) {
	echo "<b>".$gm_lang['and']."</b><br />\n";
	echo $to_addresses;
}
?>
<br />
<? echo $gm_lang['cc'] ?><br />
<input name="cc" title="<? echo $gm_lang['cc'] ?>" format="*m" emptyok="true" />
<? if ($cc_limit) echo "<small>".sprintf($gm_lang['only_first_x_kept'],$max_cc_reply_to_all,$total_cc)."</small><br />\n"; ?>
<?
if (count($_SESSION['gm_cc_index']) > 0) {
	echo "<b>".$gm_lang['and']."</b><br />\n";
	echo $cc_addresses;
}
?>
<br />
<? echo $gm_lang['bcc'] ?><br />
<input name="bcc" title="<? echo $gm_lang['bcc'] ?>" format="*m" emptyok="true" />
<?
if (count($_SESSION['gm_bcc_index']) > 0) {
	echo "<b>".$gm_lang['and']."</b><br />\n";
	echo $bcc_addresses;
}
?>
<br />
<? echo $gm_lang['subject'] ?><br />
<input name="subj" title="<? echo $gm_lang['subject'] ?>" format="*m" emptyok="true" maxlength="250" /><br />
<? 
	// forwarded attachments
	if ($_SESSION['gm_uploaded_attach'] != "") {
		echo "<img src='clip.gif' alt='@' />&nbsp;".$gm_lang['attachments_forward_col']."<br />\n";
		echo "<select title=\"".$gm_lang['attachments_col']."\" name=\"attach\" multiple=\"true\">\n";
		$count_uploaded_attach = count($_SESSION['gm_uploaded_attach_array']);
		for ($up = 0; $up < $count_uploaded_attach; $up++) {
			echo "<option value=\"".$up."\">"
					.cleanse_string($_SESSION['gm_uploaded_attach_array'][$up]['filename'])
					."</option>\n";
		}
		echo "</select>\n";
		echo "<br />\n";
	
	}
	
	// attachments uploaded from phone
	echo "<img src='clip.gif' alt='@' />&nbsp;".$gm_lang['attachments_upload_col']."<br />\n";
	if ($conf['enable_attach']) {
		if (ereg("text/html", ACCEPT) or ereg("\*/\*", ACCEPT)) {
			$attach_count = count($_SESSION['gm_attach_filename']);
			if ($attach_count > 0) {
				for ($i=0;$i < $attach_count; $i++) {
					echo cleanse_string(basename($_SESSION['gm_attach_filename'][$i]))."<br />\n";
				}
			} else {
				echo $gm_lang['none_paren']."<br />\n";
			}
			//echo "<a href=\"".basename(SELF)."?action=attach".GMID."\">".$gm_lang['upload_attachment']."</a><br /><br />\n";
			?><anchor title="<? echo $gm_lang['upload_attachment'] ?>"><go href="compose.php?action=attach&amp;<? echo strip_tags(SID) ?>" method="post">
				<postfield name="subj" value="$(subj)" />
				<postfield name="body" value="$(body)" />
				<postfield name="to" value="$(to)" />
				<postfield name="cc" value="$(cc)" />
				<postfield name="bcc" value="$(bcc)" />
				<postfield name="from" value="$(from)" />
				<postfield name="attach" value="$(attach)" />
			<? if ($_SESSION['gm_setting_gen_cache']['use_signature']) { ?>
				<postfield name="sign" value="$(sign)" />
			<? } ?>
			</go><? echo $gm_lang['upload_attachment'] ?></anchor>
			<br />
		<?
		} else {
			echo "<small>".$gm_lang['upload_no_support']."</small><br /><br />\n";
		}
	} else {
		echo "<small>".$gm_lang['upload_off']."</small><br /><br />\n";
		//echo "<small>".$gm_lang['upload_off']."<br />\n";
		//echo $gm_lang['feature_not_avail']."</small><br />\n";
	} 

echo "<br />\n";	
echo $gm_lang['message']."<br />\n";
echo "<small>".$gm_lang['return_character']?></small><br />
<input name="body" title="<? echo $gm_lang['message_text'] ?>" format="*M" emptyok="true" />
<?
if (/* $_SESSION['gm_use_sign'] or */ $_SESSION['gm_include_orig'] or $_SESSION['gm_forward']) {
	echo "<b><small>\n";
	echo $gm_lang['attached_col']." ";
/* 	if ($_SESSION['gm_use_sign']) echo $gm_lang['signature']; */
	if ($_SESSION['gm_include_orig']) {
/* 		if ($_SESSION['gm_use_sign']) echo ", "; */
		echo $gm_lang['quoted_text'];
	} elseif ($_SESSION['gm_forward']) {
/* 		if ($_SESSION['gm_use_sign']) echo ", "; */
		echo $gm_lang['forwarded_message'];
	}
	echo "</small></b>\n";
}

echo "<br /><br />\n";
if ($_SESSION['gm_setting_gen_cache']['use_signature']) {
	echo $gm_lang['include_sig_quest'];
?>
<select title="<? echo $gm_lang['include_sig_quest'] ?>" name="sign">
	<option value="0"><? echo $gm_lang['no'] ?></option>
	<option value="1"><? echo $gm_lang['yes'] ?></option>
</select>
<br />
<? } ?>

<anchor title="<? echo $gm_lang['send'] ?>"><go href="compose.php?action=send&amp;<? echo strip_tags(SID) ?>" method="post">
	<postfield name="subj" value="$(subj)" />
	<postfield name="body" value="$(body)" />
	<postfield name="to" value="$(to)" />
	<postfield name="cc" value="$(cc)" />
	<postfield name="bcc" value="$(bcc)" />
	<postfield name="from" value="$(from)" />
	<postfield name="attach" value="$(attach)" />
<? if ($_SESSION['gm_setting_gen_cache']['use_signature']) { ?>
	<postfield name="sign" value="$(sign)" />
<? } ?>
</go><? echo $gm_lang['send'] ?></anchor>
<br />
<anchor title="<? echo $gm_lang['save_as_draft'] ?>"><go href="compose.php?action=save&amp;<? echo strip_tags(SID) ?>" method="post">
	<postfield name="subj" value="$(subj)" />
	<postfield name="body" value="$(body)" />
	<postfield name="to" value="$(to)" />
	<postfield name="cc" value="$(cc)" />
	<postfield name="bcc" value="$(bcc)" />
	<postfield name="from" value="$(from)" />
	<postfield name="attach" value="$(attach)" />
<? if ($_SESSION['gm_setting_gen_cache']['use_signature']) { ?>
	<postfield name="sign" value="$(sign)" />
<? } ?>
</go><? echo $gm_lang['save_as_draft'] ?></anchor>
<br />
<a href="#discard"><? echo $gm_lang['discard_quest'] ?></a><br />
<a href='<? echo basename(SELF)."?action=discard".RANDOM.GMID; ?>'><? echo $gm_lang['discard_for_sure'] ?></a><br />
<br />
</p>
</card>
<card id="discard" title="<? echo $gm_lang['discard_message'] ?>">
<p>
<? 
// display a system-wide message
system_message();	

echo $gm_lang['sure_to_discard'] ?>
</p>
<p align="center">
<a href="#main"><? echo $gm_lang['no'] ?></a> ||| <a href='<? echo basename(SELF)."?action=discard".RANDOM.GMID; ?>'><? echo $gm_lang['yes'] ?></a>
</p>
<?
print_footer();


function reply_options($message) {
	global $gm_lang;
	global $max_cc_reply_to_all;

	print_headers();			// send wml headers
	include("template.php");	// print template

?>
<card id="main" title="<? echo $gm_lang['reply_options'] ?>">
<onevent type="onenterforward">
<refresh>
	<setvar name="all" value="0" />
	<setvar name="inc_orig" value="0" />
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

echo $gm_lang['reply_options'] ?><br />
<br />
<? echo $gm_lang['reply_to'] ?><br />
<?
if (!isset($message->conv[0]['recv_email'])) {
	//debug_print(basename(__FILE__).": ".__LINE__.": undefined conv[0]['recv_email'], dumping message:\n".print_r($message,true));
}
$sent_to = (count($message->conv[0]['recv_email']) + count($message->conv[0]['cc_email']));
if ($sent_to > 0) { 
?>
<small><? echo sprintf($gm_lang['max_per_field'],$max_cc_reply_to_all) ?></small><br />
<? } ?>
<select title="<? echo $gm_lang['reply_to'] ?>" name="all">
	<option value="0"><? echo $gm_lang['sender'] ?></option>
<?
if (count($message->conv[0]['recv_email']) > 0) { 
?>
	<option value="1"><? echo $gm_lang['sender_and_to'] ?>(<? echo count($message->conv[0]['recv_email']) ?>)</option>
<? } 
if (count($message->conv[0]['cc_email']) > 0) { 
?>
	<option value="2"><? echo $gm_lang['sender_and_to_cc'] ?>(<? echo $sent_to ?>)</option>
<? } ?>
</select>
<br />

<anchor title="<? echo $gm_lang['continue_reply'] ?>"><go href="compose.php" method="post">
	<postfield name="th" value="<? echo $_SESSION['gm_reply_th']; ?>" />
	<postfield name="mg" value="<? echo $_SESSION['gm_reply_mg']; ?>" />
	<postfield name="all" value="$(all)" />
	<postfield name="inc_orig" value="$(inc_orig)" />
	<postfield name="action" value="reply2" />
	<postfield name="<? echo session_name(); ?>" value="<? echo session_id(); ?>" />
</go><? echo $gm_lang['continue_reply'] ?></anchor>
<br />

<anchor><prev/><? echo $gm_lang['cancel'] ?></anchor><br />
<br />
</p>
<?
	print_footer();


}


function html_attach($limit) {

	global $gm_lang;
	global $conf;
	
	print_headers("html");
?>
<html>
<head>
	<title><? echo $gm_lang['compose_mail']." - ".$gm_lang['attachments'] ?></title>
	<meta content="text/html; charset=utf-8" http-equiv="content-type">
	<meta http-equiv="Cache-Control" content="max-age=1, must-revalidate, no-cache">
</head>
<body>
	<form action="compose.php?action=upload&amp;<? echo session_name().'='.session_id() ?>" enctype="multipart/form-data" method="post">
		<p style="color:red">
		<? echo $gm_lang['upload_warning'] ?>
		</p>
		<p>
			<? echo sprintf($gm_lang['upload_limit'],(ceil($limit/1024))) ?><br />
			<br />
			<? //<input type="hidden" name="MAX_FILE_SIZE" value="<? echo $limit ? >" /> ?>
			<input type="hidden" name="<? echo session_name() ?>" value="<? echo session_id() ?>" />
			<img src='clip.gif' alt='@' /><? echo $gm_lang['attachments_col'] ?><br />
			<br />
		<? for ($i = 1; $i <= $conf['attach_up_number']; $i++) { ?>
			<input type="file" name="attach<? echo $i ?>" /><br />
		<? } ?>
			<br />
			<input type="submit" value="<? echo $gm_lang['done'] ?>" /><br />
		</p>
	</form>
	<form action="compose.php?action=up_cancel&amp;<? echo session_name().'='.session_id() ?>">
		<p>
			<input type="hidden" name="<? echo session_name() ?>" value="<? echo session_id() ?>" />
			<input type="submit" value="<? echo $gm_lang['cancel'] ?>" /><br />
		</p>
	</form>
</body>
</html>
<?
}

///////////////
//
// Functions
//

// removes a directory and all contents
// rmdirr('/path/to/dir');
function rmdirr($dir_name) {
	$skip = array('.','..');

	if (!$sourcedir = @opendir($dir_name))  return false;

	while(false !== ($dir_item = readdir($sourcedir))) {
		if(!in_array($dir_item, $skip)) {
			$object = str_replace('//','/', $dir_name.'/'.$dir_item);
			if(is_dir($object)) rmdirr($object);
			if(is_file($object)) @unlink($object);
		}
	}

	closedir($sourcedir);
	if ($result = @rmdir($dir_name)) {
		return true;
	} else {
		return false;
	}
}

?>