<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
// display/search results
$search_query	= (isset($_REQUEST['query'])) 	? trim($_REQUEST['query'])	: "";
$which_contacts	= (isset($_REQUEST['dis'])) 	? $_REQUEST['dis']	: "freq";

// display x contacts per page
if ($_SESSION['gm_msg_per_page'] < $conf['num_msgs']) {
	$display = 8;
} elseif ($_SESSION['gm_msg_per_page'] > $conf['num_msgs']) {
	$display = 20;
} else {
	$display = 15;
}

if (isset($_REQUEST['p'])) {
	$_SESSION['gm_contact_page'] = $_REQUEST['p'];
} elseif (isset($_REQUEST['sel'])) {
	$_SESSION['gm_contact_page'] = 0;
} elseif (!isset($_SESSION['gm_contact_page'])) {
	$_SESSION['gm_contact_page'] = 0;
}
$page = $_SESSION['gm_contact_page'];

// adding/editing/delete contact
$action			= (isset($_REQUEST['act'])) 	? $_REQUEST['act']			: "";
$confirm		= (isset($_REQUEST['conf'])) 	? $_REQUEST['conf']			: 0 ;
$id				= (isset($_REQUEST['id'])) 		? $_REQUEST['id']			: "";
$name			= (isset($_REQUEST['name'])) 	? $_REQUEST['name']			: "";
$email			= (isset($_REQUEST['email']))	? $_REQUEST['email']		: "";
$notes			= (isset($_REQUEST['notes'])) 	? $_REQUEST['notes']		: "";
$contact_id		= (isset($_REQUEST['cid'])) 	? $_REQUEST['cid']			: "";

// other actions
$view			= (isset($_REQUEST['v'])) 		? $_REQUEST['v']	: 0;
$done			= (isset($_REQUEST['d'])) 		? $_REQUEST['d']	: 0;
$select			= (isset($_REQUEST['sel']))		? $_REQUEST['sel']	: 0;


// compose
$max_per_field 	= 50;	// set limit for number of addresses per to, cc, or bcc field

// initializes variables
if (!isset($_SESSION['gm_to_index']))  $_SESSION['gm_to_index']  = array();
if (!isset($_SESSION['gm_cc_index']))  $_SESSION['gm_cc_index']  = array();
if (!isset($_SESSION['gm_bcc_index'])) $_SESSION['gm_bcc_index'] = array();

// retrieves the contacts
// cache the contacts
if (	   (!isset($_SESSION['gm_contacts_all'])) 
		or (!isset($_SESSION['gm_contacts_freq']))
		or (!isset($_SESSION['gm_contacts_group']))
		or (!isset($_SESSION['gm_contacts_index']))
		or ($select)
	) {
	update_cache();
}


// retrieves cached info
if ($which_contacts == "all") {
	$snapshot = $_SESSION['gm_contacts_all'];
} elseif ($which_contacts == "grp") {
	$snapshot = $_SESSION['gm_contacts_group'];
} elseif ($which_contacts == "search") {
	$gmailer->fetchBox(GM_CONTACT, "search", "$search_query");
	$snapshot = $gmailer->getSnapshot(GM_CONTACT);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
} else {
	$snapshot = $_SESSION['gm_contacts_freq'];
}

// debugging
//debug_print("contacts snapshot: ".print_r($snapshot,true));
//debug_print("contacts gmailer object: ".print_r($gmailer,true));
//debug_print($_SESSION['gm_contacts_index'][127].",".$_SESSION['gm_contacts_all']->contacts[$_SESSION['gm_contacts_index'][127]]['email']);

if ($name != "") $name = stripslashes(trim($name));
if ($email != "") $email = stripslashes(trim($email));
if ($notes != "") $notes = stripslashes(trim($notes));

$status_message = "";

// if an recipient is specified
if (isset($_REQUEST['c_ids']) and 
		($action != "e") and ($action != "d") and ($action != "v") and ($action != "a")
	) {
	$ids = explode(";",$_REQUEST['c_ids']);
	$in_field = explode(";",str_replace(")","",$_REQUEST['c_vals']));
	$fields = array("null","to","cc","bcc");

	$count_ids = count($ids);
	for ($i=0 ; $i < $count_ids; $i++) {
		$contact_id = $ids[$i];
		if ($contact_id == "-1") continue;
		$c_in_field = $in_field[$i];
		
		// remove the recipient if it already exists
		$exists_to = array_search("$contact_id", $_SESSION['gm_to_index']);
		if (!($exists_to === false)) unset($_SESSION['gm_to_index'][$exists_to]);
		$exists_cc = array_search("$contact_id", $_SESSION['gm_cc_index']);
		if (!($exists_cc === false)) unset($_SESSION['gm_cc_index'][$exists_cc]);
		$exists_bcc = array_search("$contact_id", $_SESSION['gm_bcc_index']);
		if (!($exists_bcc === false)) unset($_SESSION['gm_bcc_index'][$exists_bcc]);

		// if a recipient needs to be added to a field
		if ($c_in_field > 0) {
			$field = $fields[$c_in_field];
			if ((count($_SESSION["gm_$field"."_index"]) < $max_per_field)) {
				// add the recipient to the correct field
				$_SESSION["gm_$field"."_index"][] = "$contact_id";
			} else {
				// exceded maximum recipients per field
				$status_message = sprintf($gm_lang['error_max_recipients'],$max_per_field);
			}
		}		
	}
	
	// if we are done and there are no errors
	if ($done and $status_message == "") {
		$url = "compose.php?sel=1";
	
		// actual redirection
		redirect_page($url, $gm_lang['compose_mail'], $gm_lang['update_address_fld']);	

		unset($_SESSION['gm_contact_page']);

		exit();
	}
} elseif ($action == "e") {
	if ($confirm) {
		$gmailer->fetchBox(GM_CONTACT, "detail", "$contact_id");
		$temp_snapshot = $gmailer->getSnapshot(GM_CONTACT);
		if ($temp_snapshot->created == 0) static_error($temp_snapshot->snapshot_error);

		$details = (isset($temp_snapshot->contacts[0]['details'])) 
			? $temp_snapshot->contacts[0]['details']
			: array ()
			;

		$status = $gmailer->editContact("$contact_id","$name","$email","$notes",$details);
		$url = "contact.php?v=1&amp;dis=all&amp;cid=$contact_id";
		$status_message	= $gmailer->lastActionStatus('message');
		
		// actual redirection
		redirect_page($url, $gm_lang['edit_contact'], $gm_lang['editing_contact']."<br /><b>$status_message</b>",1);	
	
		if ($status) {
			// updates cached contacts
			update_cache();
		}
		exit;
		
	} else {
		$ids 	= explode(";",$_REQUEST['c_ids']);
		$values = explode(";",str_replace(")","",$_REQUEST['c_vals']));
	
		$contact_id = "";
		$count_ids = count($ids);
		for ($i=0 ; $i < $count_ids; $i++) {
			if ($values[$i] == "e") {
				$contact_id = $ids[$i];
				break;
			}
		}
		if ($contact_id != "") {
			$count_contacts = count($_SESSION['gm_contacts_all']->contacts);
			for ($i=0 ; $i < $count_contacts; $i++) {
				$id = $_SESSION['gm_contacts_all']->contacts[$i]['id'];
				if ("$contact_id" == "$id") {
					$email = $_SESSION['gm_contacts_all']->contacts[$i]['email'];
					$name = $_SESSION['gm_contacts_all']->contacts[$i]['name'];
					$notes = $_SESSION['gm_contacts_all']->contacts[$i]['notes'];
					break;
				}
			}
			print_edit_contact();
			exit();
		} else {
			$status_message = $gm_lang['pls_choose_con_edit'];
			$action = "";
		}
	}
	
} elseif ($action == "d") {
		$ids 	= explode(";",$_REQUEST['c_ids']);
		$values = explode(";",str_replace(")","",$_REQUEST['c_vals']));
	
		$delete_ids = array();
		$count_ids = count($ids);
		for ($i=0 ; $i < $count_ids; $i++) {
			if ($values[$i] == "d") $delete_ids[] = $ids[$i];
		}
		
		if (count($delete_ids) == 0) {
			$status_message = $gm_lang['pls_choose_con_del'];
			$action = "";
		} else {
			if (count($delete_ids) == 1){
				// if only one, makes it a string
				$delete_ids = $delete_ids[0];
			}
			
			$status			= $gmailer->deleteContact($delete_ids);
			$status_message	= $gmailer->lastActionStatus('message');
	
			if ($status) {
				$url = "contact.php?v=1&amp;p=$page&amp;dis=$which_contacts";
			
				// actual redirection
				redirect_page($url, $gm_lang['delete_contact'], "<b>$status_message</b>");	
		
				// updates cached contacts
				update_cache();
					
				exit();
			}
		}

} elseif ($action == "a") {
	if ($confirm) {
		$status			= $gmailer->editContact(-1,"$name","$email","$notes",array());
		$status_message	= $gmailer->lastActionStatus('message');
		$contact_id		= $gmailer->lastActionStatus('contact_id');
		$url = "contact.php?v=1&amp;dis=all&amp;cid=$contact_id";

		if (!$status) $status_message = $gm_lang['error_col']." ". (($status_message != "") ? $status_message : $gm_lang['unknown']) ;
	
		// actual redirection
		redirect_page($url, $gm_lang['add_contact'], "<b>$status_message</b>");	
	
		if ($status) {
			// updates cached contacts
			update_cache();
 		} 
	} else {
		print_add_contact();
	}
	exit();
	

} elseif ($action == "v") {
	$ids 	= explode(";",$_REQUEST['c_ids']);
	$values = explode(";",str_replace(")","",$_REQUEST['c_vals']));

	$contact_id = "";
	$count_ids = count($ids);
	for ($i=0 ; $i < $count_ids; $i++) {
		if ($values[$i] == "v") {
			$contact_id = $ids[$i];
			break;
		}
	}
	if ($contact_id != "") {
		$contact_index = $_SESSION['gm_contacts_index']["$contact_id"];
		$is_group = $_SESSION['gm_contacts_all']->contacts["$contact_index"]['is_group'];

		if ($is_group) {
			$gmailer->fetchBox(GM_CONTACT, "group_detail", "$contact_id");
		} else {
			$gmailer->fetchBox(GM_CONTACT, "detail", "$contact_id");
		}
		$temp_snapshot = $gmailer->getSnapshot(GM_CONTACT);
		if ($temp_snapshot->created == 0) static_error($temp_snapshot->snapshot_error);
		//debug_print("contacts raw: ".print_r($gmailer->dump_raw(),true));
		//debug_print("contacts snapshot: ".print_r($temp_snapshot,true));
		print_view_contact($temp_snapshot->contacts[0]);
		exit();
	} else {
		$status_message = $gm_lang['pls_choose_con_view'];
		$action = "";
	}
}

if (!isset($snapshot->contacts)) {
	//debug_print("contacts not found (".basename(__FILE__).": ".__LINE__."), dumping snapshot: ".print_r($snapshot,true));
	$c_count = 0;
} else {
	$c_count = count($snapshot->contacts);
}
$pages = ceil($c_count / $display);
if ($view and $contact_id != "") {
	for ($i=0 ; $i < $c_count ; $i++) {
		if ($snapshot->contacts[$i]['id'] == "$contact_id") {
			$page = floor($i / $display);
			break;
		}
	}
}
$start = $page*$display;

$ids = "-1";
$values = "-1";
$set_vars = "";
for ($i = $start ; $i < $start+$display and $i < $c_count; $i++) {
	$id	= $snapshot->contacts[$i]['id'];
		$ids .= ";".$id;
		$values .= ";"."$(c_".$id.")";
}

for ($i = $start ; $i < $start+$display and $i < $c_count; $i++) {
	$id	= $snapshot->contacts[$i]['id'];
	$value = 0;
	if (!$view) {
		$exists_to = array_search("$id", $_SESSION['gm_to_index']);
		if (!($exists_to === false)) $value = 1;
		$exists_cc = array_search("$id", $_SESSION['gm_cc_index']);
		if (!($exists_cc === false)) $value = 2;
		$exists_bcc = array_search("$id", $_SESSION['gm_bcc_index']);
		if (!($exists_bcc === false)) $value = 3;
	}
	$set_vars .= "<setvar name=\"c_$id\" value=\"$value\" />\n";
}

print_headers();			// send wml headers
include("template.php");	// print template

?>
<card title="<? echo $gm_lang['contacts'] ?>" id='main'>
<onevent type="onenterforward">
<refresh>
<setvar name="p" value="<? echo $page ?>" />
<setvar name="query" value="<? echo cleanse_string($search_query) ?>" />
<? echo $set_vars ; ?>
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

echo "<b>";
if (isset($status_message) and $status_message !="") echo $status_message."<br /><br />\n";

echo $gm_lang['contacts']."<br />";
echo "</b><small>\n";
if ($which_contacts == "freq") {
	echo "<b>--&gt; ".$gm_lang['freq_mailed']."</b><br />\n";
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=all&amp;query=".RANDOM.GMID."\">".$gm_lang['all_contacts']."</a><br />\n";
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=grp&amp;query=".RANDOM.GMID."\">".$gm_lang['groups']."</a>";
} elseif ($which_contacts == "all") {
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=freq&amp;query=".RANDOM.GMID."\">".$gm_lang['freq_mailed']."</a><br />\n";
	echo "<b>--&gt; ".$gm_lang['all_contacts']."</b><br />\n";
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=grp&amp;query=".RANDOM.GMID."\">".$gm_lang['groups']."</a>";
} elseif ($which_contacts == "grp") {
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=freq&amp;query=".RANDOM.GMID."\">".$gm_lang['freq_mailed']."</a><br />\n";
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=all&amp;query=".RANDOM.GMID."\">".$gm_lang['all_contacts']."</a><br />\n";
	echo "<b>--&gt; ".$gm_lang['groups']."</b>";
} else {
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=freq&amp;query=".RANDOM.GMID."\">".$gm_lang['freq_mailed']."</a><br />\n";
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=all&amp;query=".RANDOM.GMID."\">".$gm_lang['all_contacts']."</a><br />\n";
	echo "<a href=\"".basename(SELF)."?v=$view&amp;p=0&amp;dis=grp&amp;query=".RANDOM.GMID."\">".$gm_lang['groups']."</a>";
}
echo "</small><br />";
echo "<input title=\"".$gm_lang['search_contacts_col']."\" name=\"query\" format=\"*m\" emptyok=\"true\" />\n";
if ($which_contacts == "search") echo "<b>";
echo "<small><a href=\"".basename(SELF).
	"?v=$view&amp;p=0&amp;dis=search&amp;query=$(query)".
	RANDOM.GMID."\">";
if ($which_contacts == "search") echo "--&gt; ";
echo $gm_lang['search_contacts']."</a>";
echo "<br /><br /></small>\n";
if ($which_contacts == "search") echo "</b>";

if ($pages > 1 or $page >= $pages) page_nav($pages,$view);
contact_select();

//debug_print("dumping raw contacts: ".print_r($gmailer->dump_raw(),true));	

for ($i = $start ; $i < $start+$display and $i < $c_count; $i++) {
	//debug_print("dumping contact: ".print_r($snapshot->contacts[$i],true));	

	$id		= $snapshot->contacts[$i]['id'];
	$name 	= $snapshot->contacts[$i]['name'];
	$email	= $snapshot->contacts[$i]['email'];
	$notes	= $snapshot->contacts[$i]['notes'];
	$is_grp = $snapshot->contacts[$i]['is_group'];
	$groups = (!$is_grp) ? $snapshot->contacts[$i]['groups'] : array();

	if ($name != "") echo cleanse_string($name)."<br />\n";
	$count_groups = count($groups);
	if (($email != "") or ($notes != "") or $count_groups > 0 or $is_grp) {
		echo "<small>";
		if ($is_grp) {
/* 			echo cleanse_string($snapshot->contacts[$i]['[group_total'])."<br />\n"; */
			echo "<b>".$snapshot->contacts[$i]['group_total']."</b>";
			echo cleanse_string($snapshot->contacts[$i]['group_names'])."<br />\n";
		} else {
			if ($email != "") echo cleanse_string($email)."<br />\n";
			if ($count_groups > 0) {
				for ($grp=0; $grp < $count_groups; $grp++) {
					$index = $_SESSION['gm_contacts_index'][$groups[$grp]];
					echo cleanse_string($_SESSION['gm_contacts_all']->contacts[$index]['name']);
					if ($grp != $count_groups-1) echo ", ";
				}
				echo "<br />\n";
			} 
			if ($notes != "") echo cleanse_string($notes)."<br />\n";
		}
		echo "</small>";
	}

	echo "<select name=\"c_$id\">\n";
	if ($view) {
		echo "<option value=\"0\"> - </option>\n";
		echo "<option value=\"v\">".$gm_lang['view']."</option>\n";
		if (!$is_grp) {
			echo "<option value=\"e\">".$gm_lang['edit']."</option>\n";
		}
		echo "<option value=\"d\">".$gm_lang['delete']."</option>\n";
	} else {
		echo "<option value=\"0\"> - </option>\n";
		echo "<option value=\"1\">".$gm_lang['to_simple']."</option>\n";
		echo "<option value=\"2\">".$gm_lang['cc_simple']."</option>\n";
		echo "<option value=\"3\">".$gm_lang['bcc_simple']."</option>\n";
	}
	echo "</select>\n";
	echo "<br />\n";
}

if ($pages > 1 or $page >= $pages) page_nav();
contact_select();

print_contacts_footer();
print_footer();

exit();


function page_nav() {
	global $gm_lang;
	global $pages;
	global $view;
	global $times;
	global $ids;
	global $values;
	global $page;
	global $which_contacts;
	
	if (!isset($times)) $times = 0;
	
	$page_display = $page+1;
	echo sprintf($gm_lang['page_x_go_to_y'],$page_display)." \n";
	echo "<select name=\"p\">\n";
	if ($pages == 0) {
		echo "<option value=\"0\">1</option>\n";
	} else {
		for ($i=0; $i < $pages ; $i++) {
			$page_num = $i + 1;
			echo "<option value=\"$i\">$page_num</option>\n";
		}
	}
	echo "</select>\n";
/* 	echo "<a href=\"".basename(SELF)."?v=". */
/* 		$view."&amp;p=$(p)&amp;dis=".$which_contacts. */
/* 		"&amp;query=".$search_query."&amp;c_ids=".$ids."&amp;c_vals=". */
/* 		$values."&amp;z=". */
/* 		strip_tags(SID).\">Test page</a><br /><br />"; */
	?>

	<anchor title="<? echo $gm_lang['go_to_page'] ?>"><go href="<? echo basename(SELF).'?v='.$view.'&amp;dis='.$which_contacts.'&amp;'.strip_tags(SID) ?>" method="post">
		<postfield name="p" value="$(p)" />
		<postfield name="query" value="$(q)" />
		<?
		if (!$view) {
			echo "<postfield name=\"c_ids\" value=\"".$ids."\" />\n";
			echo "<postfield name=\"c_vals\" value=\"".$values."\" />\n";
		}
		?>
	</go><? echo $gm_lang['go'] ?></anchor>
	<br />
	<br />
	<?
}

function contact_select() {
	global $pages;
	global $view;
	global $times;
	global $ids;
	global $values;
	global $page;
	global $which_contacts;
	global $gm_lang;

	if ($view) {
		if ($times == 0) {
			echo "<a href=\"main.php?sum=1".RANDOM.GMID."\">".$gm_lang['done']."</a><br /><br />\n";
			$times++;
		}
	} else {
		?>
		<anchor title="<? echo $gm_lang['done_sel_recip'] ?>"><go href="<? echo basename(SELF).'?d=1&amp;'.strip_tags(SID) ?>" method="post">
			<?
			if (!$view) {
				echo "<postfield name=\"c_ids\" value=\"".$ids."\" />\n";
				echo "<postfield name=\"c_vals\" value=\"".$values."\" />\n";
			}
			?>
		</go><? echo $gm_lang['done_sel_recip'] ?></anchor>
		<br />
		<br />
		<?
	}
}

function print_contacts_footer() {
	global $gm_lang;
	global $view;
	global $action;
	global $ids;
	global $values;
	global $which_contacts;
	global $page;
	
	

	if ($view) {
		if ($action != "a" and $action != "d" and $action != "e") {
			?>
			<anchor title="<? echo $gm_lang['view_details'] ?>"><go href="<? echo basename(SELF).'?v=1&amp;act=v&amp;dis='.$which_contacts.'&amp;'.strip_tags(SID) ?>" method="post">
				<?
				echo "<postfield name=\"c_ids\" value=\"".$ids."\" />\n";
				echo "<postfield name=\"c_vals\" value=\"".$values."\" />\n";
				?>
			</go><? echo $gm_lang['view_details'] ?></anchor>
			<br />
			<anchor title="<? echo $gm_lang['edit_contact'] ?>"><go href="<? echo basename(SELF).'?v=1&amp;act=e&amp;'.strip_tags(SID) ?>" method="post">
				<?
				echo "<postfield name=\"c_ids\" value=\"".$ids."\" />\n";
				echo "<postfield name=\"c_vals\" value=\"".$values."\" />\n";
				?>
			</go><? echo $gm_lang['edit_contact'] ?></anchor>
			<br />
			<anchor title="<? echo $gm_lang['delete'] ?>"><go href="<? echo basename(SELF).'?v=1&amp;act=d&amp;dis='.$which_contacts.'&amp;p='.$page.'&amp;'.strip_tags(SID) ?>" method="post">
				<?
				echo "<postfield name=\"c_ids\" value=\"".$ids."\" />\n";
				echo "<postfield name=\"c_vals\" value=\"".$values."\" />\n";
				?>
			</go><? echo $gm_lang['del_contacts'] ?></anchor>
			<br />
			<?
			echo "<a href='contact.php?v=1&amp;act=a".RANDOM.GMID."'>".$gm_lang['add_contact']."</a><br />\n";
		} else {
			echo "<a href='contact.php?v=1&amp;p=0".RANDOM.GMID."'>".$gm_lang['contacts']."</a><br />\n";
		}
	}
	echo "----------<br />\n";
	echo "<a href='main.php?sum=1".RANDOM.GMID."'>".$gm_lang['summary']."</a><br />\n";
	echo "<a href='compose.php?action=new&amp;back=contact.phpQUESTvEQUAL$view".RANDOM.GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
	echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['settings']."</a><br />\n";
	echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
	echo "</p>\n";
}


function print_add_contact() {
	global $gm_lang;
	global $name;
	global $email;
	global $notes;
	global $status_message;
	global $view;
	global $display;
	global $page;


	print_headers();	// send wml headers
	?>
<template>
	<do type="prev" label="Back" name="z"><prev/></do>
</template>
<card title='Add Contact' id='main'>
<onevent type="onenterforward">
<refresh>
<setvar name="name" value="<? echo cleanse_string($name) ?>" />
<setvar name="email" value="<? echo cleanse_string($email) ?>" />
<setvar name="notes" value="<? echo cleanse_string($notes) ?>" />
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

?><b><?
if (isset($status_message) and $status_message !="") echo $status_message."<br /><br />\n";
?>
<? echo $gm_lang['add_contact'] ?><br />
<br />
</b>
<? echo $gm_lang['name'] ?><br />
<input title="<? echo $gm_lang['name'] ?>" name="name" format="*m" emptyok="true" /><br />

<? echo $gm_lang['primary_email'] ?><br />
<input title="<? echo $gm_lang['primary_email'] ?>" name="email" format="*m" emptyok="true" /><br />
	
<? echo $gm_lang['notes'] ?><br />
<input title="<? echo $gm_lang['notes'] ?>" name="notes" format="*m" emptyok="true" /><br />

<anchor title="<? echo $gm_lang['save'] ?>"><go href="<? echo basename(SELF); ?>" method="post">
	<postfield name="name" value="$(name)" />
	<postfield name="email" value="$(email)" />
	<postfield name="notes" value="$(notes)" />
	<postfield name="act" value="a" />
	<postfield name="conf" value="1" />
	<postfield name="v" value="1" />
	<postfield name="<? echo session_name(); ?>" value="<? echo session_id(); ?>" />
</go><? echo $gm_lang['save'] ?></anchor>
<br />
<br />
<a href="contact.php?v=$view&amp;dis=$display&amp;p=$page<? echo RANDOM.GMID ?>"><? echo $gm_lang['cancel'] ?></a><br />
<br />

	<?
	print_contacts_footer();
	print_footer();

}

function print_edit_contact() {
	global $gm_lang;
	global $contact_id;
	global $name;
	global $email;
	global $notes;
	global $status_message;
	global $view;
	global $display;
	global $page;
	
	print_headers();	// send wml headers
	?>
<template>
	<do type="prev" label="<? echo $gm_lang['back'] ?>" name="z"><prev/></do>
</template>
<card title="<? echo $gm_lang['edit_contact'] ?>" id='main'>
<onevent type="onenterforward">
<refresh>
<setvar name="name" value="<? echo cleanse_string($name) ?>" />
<setvar name="email" value="<? echo cleanse_string($email) ?>" />
<setvar name="notes" value="<? echo cleanse_string($notes) ?>" />
</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

?><b><?
if (isset($status_message) and $status_message !="") echo $status_message."<br /><br />\n";
?>
<? echo $gm_lang['edit_contact'] ?><br />
<br />
</b>
<? echo $gm_lang['name'] ?><br />
<input title="<? echo $gm_lang['name'] ?>" name="name" format="*M" emptyok="true" /><br />

<? echo $gm_lang['primary_email'] ?><br />
<input title="<? echo $gm_lang['primary_email'] ?>" name="email" format="*m" emptyok="true" /><br />
	
<? echo $gm_lang['notes'] ?><br />
<input title="<? echo $gm_lang['notes'] ?>" name="notes" format="*M" emptyok="true" /><br />

<anchor title="<? echo $gm_lang['save'] ?>"><go href="<? echo basename(SELF); ?>" method="post">
	<postfield name="cid" value="<? echo $contact_id ?>" />
	<postfield name="name" value="$(name)" />
	<postfield name="email" value="$(email)" />
	<postfield name="notes" value="$(notes)" />
	<postfield name="act" value="e" />
	<postfield name="conf" value="1" />
	<postfield name="v" value="1" />
	<postfield name="<? echo session_name(); ?>" value="<? echo session_id(); ?>" />
</go><? echo $gm_lang['save'] ?></anchor>
<br />
<br />
<a href="contact.php?v=<? echo $view ?>&amp;dis=<? echo $display ?>&amp;p=<? echo $page.RANDOM.GMID ?>"><? echo $gm_lang['cancel'] ?></a><br />
<br />

	<?
	print_contacts_footer();
	print_footer();

}

function print_view_contact($contact) {

	global $gm_lang;
	global $temp_snapshot;
	global $which_contacts;
	global $contact_id;
	
	//debug_print("contact: ".print_r($contact,true));
	
	print_headers();	// send wml headers
	?>
<template>
	<do type="prev" label="<? echo $gm_lang['back'] ?>" name="z"><prev/></do>
</template>
<card title="<? echo $gm_lang['contact_details'] ?>" id='main'>
<p>
<?
// display a system-wide message
system_message();

echo "<big><b>".$contact['name']."</b></big><br />\n";

if ($contact['is_group']) {
	echo "<br />";
	$count_temp_details = count($contact['members']);
	if (count($count_temp_details) > 0 ) {
		for ($i = 0; $i < $count_temp_details; $i++) {
			echo "<b>".cleanse_string($contact['members'][$i]['name'])."</b><br />\n";
			echo cleanse_string($contact['members'][$i]['email'])."<br /><br />\n";
		}
	}	

} else { 
	echo "&lt;".$contact['email']."&gt;<br /><br />\n";
	$count_groups = count($contact['groups']);
	//debug_print("contact's groups: ".print_r($contact['groups'],true));
	if ($count_groups > 0) {
		for ($grp=0; $grp < $count_groups; $grp++) {
			$index = $_SESSION['gm_contacts_index'][$contact['groups'][$grp]];
			echo cleanse_string($_SESSION['gm_contacts_all']->contacts[$index]['name']);
			if ($grp != $count_groups-1) echo ", ";
		}
		echo "<br />\n";
	} 
	echo $contact['notes']."<br /><br />\n";
	$count_temp_details = count($contact['details']);
	if (count($count_temp_details) > 0 ) {
		for ($i = 0; $i < $count_temp_details; $i++) {
			echo "--------------------<br />\n";
			echo "<b>".$contact['details'][$i][0]['info']."</b><br /><br />\n";
			$count_temp_details2 = count($contact['details'][$i]);
			for ($j = 1; $j < $count_temp_details2; $j++) {
				echo ucfirst($contact['details'][$i][$j]['type']).": ";
				echo $contact['details'][$i][$j]['info']."<br /><br />\n";
			}
		}
	}
} 

?>

<a href="<? echo basename(SELF) ?>?v=1&amp;cid=<? echo $contact_id ?>&amp;dis=<?
echo $which_contacts . RANDOM.GMID ?>"><? echo $gm_lang['back_to_contacts'] ?></a><br />
<br />
</p>

	<?
	print_footer();



}

function update_cache() {
	global $gmailer;

	// updates cached contacts

	// all contacts
	$gmailer->fetchBox(GM_CONTACT, "all", 0);
	$snapshot = $gmailer->getSnapshot(GM_CONTACT);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	$_SESSION['gm_contacts_all'] = $snapshot;
	
	// creates an reverse index of contacts (contact id -> index position)
	$contacts_index = array();
	$all_count = count($_SESSION['gm_contacts_all']->contacts);
	for ($i = 0; $i < $all_count; $i++) {
		$contacts_index[$_SESSION['gm_contacts_all']->contacts[$i]['id']] = $i;
	}
	$_SESSION['gm_contacts_index'] = $contacts_index;
	//debug_print("contacts index: ".print_r($_SESSION['gm_contacts_index'],true));

	// frequently mailed contacts
	$gmailer->fetchBox(GM_CONTACT, "freq", 0);
	$snapshot = $gmailer->getSnapshot(GM_CONTACT);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	$_SESSION['gm_contacts_freq'] = $snapshot;
	//debug_print("contacts gmailer object: ".print_r($gmailer,true));

	// groups
	$gmailer->fetchBox(GM_CONTACT, "group", 0);
	$snapshot = $gmailer->getSnapshot(GM_CONTACT);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);
	$_SESSION['gm_contacts_group'] = $snapshot;
	//debug_print("contacts gmailer object: ".print_r($gmailer,true));

}

?>