<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

/////////////////////////
//
// Define constants, default variables, 
// and basic repetitive
// tasks of gmail-mobile
//
/////////////////////////

// !!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT ALTER THIS FILE UNLESS YOU
// REALLY KNOW WHAT YOU ARE DOING!!
//
// Even then, there is no reason to edit
// this file ! ;-)
//
// !!!!!!!!!!!!!!!!!!!!!!

// version number
define("GMOB_VER",     "1.1");  

/////////////////////////
//
// error handling and logging
//

// turns html format off
ini_set('html_errors', false);		

// log, rather than display errors
ini_set('log_errors', true);		
ini_set('display_errors', false);

// log an error only once per script, rather than every instance
ini_set('ignore_repeated_errors', true);	

// define the error log file
/* error_log(syslog); */

// level of error reporting
error_reporting(E_ALL);

//
// END: error logging
//
/////////////////////////


/////////////////////////
//
// Other required files
// THESE ARE REQUIRED IN THIS ORDER
//

// Functions file
require_once("gmobile_functions.php");

// English language file
include("gmobile_lang.php");

//
// END: Other required files
//
/////////////////////////


/////////////////////////
//
// Define constants
//

if (isset($_SERVER['HTTP_USER_AGENT']) and ($_SERVER['HTTP_USER_AGENT'] != "")) { 
	define('USER_AGENT', $_SERVER['HTTP_USER_AGENT']);
} else { 
	define('USER_AGENT', "");
}

if (dirname($_SERVER['PHP_SELF']) == "/")
{ 
	define('DIR_PATH', "");
} else { 
	define('DIR_PATH', dirname($_SERVER['PHP_SELF']));
}

define('SELF', $_SERVER['PHP_SELF']);
define('HOST', $_SERVER['HTTP_HOST']);


// proxy related
// uses the server, user and password defined in config.php
define("P_PROXY",   "$conf_proxy_server");	
define("P_USER",    "$conf_proxy_user");
define("P_PWD",     "$conf_proxy_passwd");

// Random string in urls
define("RANDOM",     "&amp;z=".str_rand(5));

// Shorter phpsession id name
@ini_set("session.name", "gmid");

/** for debugger **/
// debugging data file, should be in PHP for security reasons
$D_FILE = "debug.php"; 

// debugging mode. 0 => off, 1 => on
$D_ON = 0;               

//
// END: Define constants
//
/////////////////////////


/////////////////////////
//
// Define default settings
//

// use php sessions
$session_method = (GM_USE_PHPSESSION | !GM_USE_COOKIE);   

/* Use PIN code signin */
if ( 	($conf_use_pin === true)
	 or ($conf_use_pin === false)
	 or ($conf_use_pin === 1)
	 or ($conf_use_pin === 0)
	) {
	$conf['use_pin'] = $conf_use_pin;
} else {
	$conf['use_pin'] = false;
}

// maximum message size before breaking it into parts
// uses $conf_display_msg_length defined in config.php
if ($conf_display_msg_length > 50000) {
	$conf['display_msg_length'] = 50000;
} elseif ($conf_display_msg_length == "") {
	$conf['display_msg_length'] = 2500;
} elseif ($conf_display_msg_length <= 0) {
	$conf['display_msg_length'] = 2500;
} elseif ($conf_display_msg_length < 1000) {
	$conf['display_msg_length'] = 1000;
} else {
	$conf['display_msg_length'] = $conf_display_msg_length;
}


// display x messages at a time in the mailbox
if ($conf_num_msgs > 50) {
	$conf['num_msgs'] = 50;
} elseif ($conf_num_msgs == "") {
	$conf['num_msgs'] = 10;
} elseif ($conf_num_msgs <= 0) {
	$conf['num_msgs'] = 10;
} else {
	$conf['num_msgs'] = $conf_num_msgs;
}

// Enable or disable file upload and attach
if ( 	($conf_enable_up_attach === true)
	 or ($conf_enable_up_attach === false)
	 or ($conf_enable_up_attach === 1)
	 or ($conf_enable_up_attach === 0)
	) {
	$conf['enable_attach'] = $conf_enable_up_attach;
} else {
	$conf['enable_attach'] = true;
}


// Maximum number of uploadable attachments
if ( 	 (is_numeric($conf_up_attach_num_limit))
	 and (is_int($conf_up_attach_num_limit))
	 and ($conf_up_attach_num_limit >= 0)
	 and ($conf_up_attach_num_limit <= 10)	 
	) {
	$conf['attach_up_number'] = $conf_up_attach_num_limit;
} else {
	$conf['attach_up_number'] = 3;
}

// Size limit for attachment upload from KB to bytes
if ( 	 (is_numeric($conf_up_attach_size_limit))
	 and (is_int($conf_up_attach_size_limit))
	 and ($conf_up_attach_size_limit > 0)
	) {
	$conf['attach_up_limit'] = $conf_up_attach_size_limit*1024;
} else {
	$conf['attach_up_limit'] = 10000000;
}

// Display message for a standard box as "Inbox (3)" [false]
// or "Inbox (3/126)" [true]
if ( 	($conf_disp_total_standard === true)
	 or ($conf_disp_total_standard === false)
	 or ($conf_disp_total_standard === 1)
	 or ($conf_disp_total_msgs === 0)
	) {
	$conf['disp_total_standard'] = $conf_disp_total_standard;
} else {
	$conf['disp_total_standard'] = false;
}

// Display message for a label as "MyLabel (3)" [false]
// or "MyLabel (3/126)" [true]
if ( 	($conf_disp_total_msgs === true)
	 or ($conf_disp_total_msgs === false)
	 or ($conf_disp_total_msgs === 1)
	 or ($conf_disp_total_msgs === 0)
	) {
	$conf['disp_total_msgs'] = $conf_disp_total_msgs;
} else {
	$conf['disp_total_msgs'] = false;
}


// sets the default way to display unread messages
// unread_bold is false which means 
// unread messages will display with an asterix (*)
if ( 	($conf_unread_bold === true)
	 or ($conf_unread_bold === false)
	 or ($conf_unread_bold === 1)
	 or ($conf_unread_bold === 0)
	) {
	$conf['unread_bold'] = $conf_unread_bold;
} else {
	$conf['unread_bold'] = false;
}


// set the default for view/download attachments
/* allow view/dl image attach */
if ( 	($conf_view_attach_image === true)
	 or ($conf_view_attach_image === false)
	 or ($conf_view_attach_image === 1)
	 or ($conf_view_attach_image === 0)
	) {
	$conf['view_attach_image'] = $conf_view_attach_image;
} else {
	$conf['view_attach_image'] = true;
}

/* allow dl audio attach */
if ( 	($conf_view_attach_audio === true)
	 or ($conf_view_attach_audio === false)
	 or ($conf_view_attach_audio === 1)
	 or ($conf_view_attach_audio === 0)
	) {
	$conf['view_attach_audio'] = $conf_view_attach_audio;
} else {
	$conf['view_attach_audio'] = true;
}

/* allow view html attach */
if ( 	($conf_view_attach_html === true)
	 or ($conf_view_attach_html === false)
	 or ($conf_view_attach_html === 1)
	 or ($conf_view_attach_html === 0)
	) {
	$conf['view_attach_html'] = $conf_view_attach_html;
} else {
	$conf['view_attach_html'] = true;
}

/* allow dl video attach */
if ( 	($conf_view_attach_video === true)
	 or ($conf_view_attach_video === false)
	 or ($conf_view_attach_video === 1)
	 or ($conf_view_attach_video === 0)
	) {
	$conf['view_attach_video'] = $conf_view_attach_video;
} else {
	$conf['view_attach_video'] = true;
}

/* allow dl zip attach */
if ( 	($conf_view_attach_zip === true)
	 or ($conf_view_attach_zip === false)
	 or ($conf_view_attach_zip === 1)
	 or ($conf_view_attach_zip === 0)
	) {
	$conf['view_attach_zip'] = $conf_view_attach_zip;
} else {
	$conf['view_attach_zip'] = true;
}

/* allow dl other attach */
if ( 	($conf_view_attach_other === true)
	 or ($conf_view_attach_other === false)
	 or ($conf_view_attach_other === 1)
	 or ($conf_view_attach_other === 0)
	) {
	$conf['view_attach_other'] = $conf_view_attach_other;
} else {
	$conf['view_attach_other'] = true;
}

// Size limit for attachments in Kilobytes
if ( 	 (is_numeric($conf_dl_attach_size_limit))
	 and (is_int($conf_dl_attach_size_limit))
	 and ($conf_dl_attach_size_limit >= 0)
	) {
	$conf['attach_size_limit'] = $conf_dl_attach_size_limit;
} else {
	$conf['attach_size_limit'] = 300;
}

// Links display behavior
if ( 	 (is_numeric($conf_links_display))
	 and (is_int($conf_links_display))
	 and ($conf_links_display > 0)
	 and ($conf_links_display <= 3)
	) {
	$conf['links_display'] = $conf_links_display;
} else {
	$conf['links_display'] = 3;
}

// temp dir path
$GM_TEMP_DIR = "temp";

// if the temp dir doesn't exists, create and set restricted access
if (!(file_exists($GM_TEMP_DIR))) {
	$oldumask = umask(0);
	mkdir($GM_TEMP_DIR, 0770);
	umask($oldumask);
}

// path to files in the temp dir
$conf['temp_dir'] = $GM_TEMP_DIR . DIRECTORY_SEPARATOR;

if ($conf['temp_dir'] == "t") exit; 

// write a dummy index file to prevent the web server from accessing the temp dir
if (!(file_exists($conf['temp_dir']."index.php"))) {
	$fd = fopen($conf['temp_dir']."index.php", "w");
	fwrite($fd, "<? echo 'Directory listing is not allowed'; ?".">\n");
	fclose($fd);
}
//debug_print('temp_dir: '.$GM_TEMP_DIR." : ".realpath($GM_TEMP_DIR)." : ".$conf['temp_dir']);


// END: Define default settings
//
/////////////////////////

?>
