<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
$status = false;
$status_message = "";



$action		= (isset($_GET['act'])) 		? $_GET['act']			: false;
$label		= (isset($_POST['label'])) 		? $_POST['label']		: "";
$relabel	= (isset($_POST['relabel']))	? $_POST['relabel']		: "";
$clear_history = (isset($_REQUEST['clrh']))	? $_REQUEST['clrh'] 	: false;

$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
if ($snapshot->created == 0) static_error($snapshot->snapshot_error);

if ($action == "create") {
	$label = stripslashes(trim($label));

	// perform the action
	// an accidental way to create a label by labeling a
	// non existant message with a label, which "creates" it
	// 1 = apply label, 0 = message number, $label = label
	//$gmailer->performAction(1, 0, $label);

	// perform the action
	$status			= $gmailer->editLabel("$label","create","");
	$status_message	= $gmailer->lastActionStatus('message');

} elseif (($action == "rename") and ($label != "") and ((int)$label >=0)) {
	$label = $snapshot->label_list[(int)$label];
	$relabel = stripslashes(trim($relabel));

	// rename the label
	$status			= $gmailer->editLabel("$label","rename","$relabel");
	$status_message	= $gmailer->lastActionStatus('message');

} elseif (($action == "remove") and ($label != "") and ((int)$label >=0)) {
	$label = $snapshot->label_list[(int)$label];

	// remove the label
	$status			= $gmailer->editLabel("$label","remove","");
	$status_message	= $gmailer->lastActionStatus('message');

	redirect_page(SELF, $gm_lang['labels'], $status_message, 5 ,true);
	exit;

}

if ($status) {
	// update the info
	$gmailer->fetchBox(GM_PREFERENCE, 0, 0);
	$snapshot = $gmailer->getSnapshot(GM_PREFERENCE);
	if ($snapshot->created == 0) static_error($snapshot->snapshot_error);

	// cache it for use in main.php, search.php, filter.php
	$_SESSION['gm_all_labels'] = $snapshot->label_list;
}


// for debugging
/* print_r($gmailer); */
/* print_r($snapshot); */
/* exit; */

//
// Display Label page
//
	
print_headers();	// send wml headers
	?>
<template>
	<do type="prev" label="<? echo $gm_lang['back'] ?>" name="z"><prev/></do>
</template>
<?
if ($clear_history) { ?>
<card title="<? echo $gm_lang['labels'] ?>" id='main' newcontext='true'>
<? } else { ?>
<card title="<? echo $gm_lang['labels'] ?>" id='main'>
<? } ?>
<p>
<?
// display a system-wide message
system_message();	

if ($status_message != "") echo "<em>".$status_message."</em><br /><br />\n";
?>
<b><? echo $gm_lang['labels'] ?></b> <? echo $gm_lang['conversations_paren'] ?><br />
<br />
<?
	$has_labels = (count($snapshot->label_list) > 0) ? true : false ;
	if ($has_labels) {
		reset($snapshot->label_list);
		foreach ($snapshot->label_list as $indexval => $label_name) {
			echo cleanse_string($label_name);
			echo " (".$snapshot->label_total[$indexval].")<br />\n";
		}
	} else {
		echo $gm_lang['have_no_labels']."<br />\n";
	}
	echo "<br />\n";
	echo "<a href='#create'>".$gm_lang['create_new_label']."</a><br />\n";
	if ($has_labels) {
		echo "<a href='#rename'>".$gm_lang['rename_label']."</a><br />\n";
		echo "<a href='#remove'>".$gm_lang['remove_label']."</a><br />\n";
	}
	echo "--------<br />\n";
	print_settings_footer();
?>
</card>

<card title="<? echo $gm_lang['create_label_cap'] ?>" id='create'>
<onevent type="onenterforward">
	<refresh>
		<setvar name="label" value=""/>
	</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

?><br />
<? echo $gm_lang['create_new_lbl_col'] ?><br />
<input name="label" title="<? echo $gm_lang['create_new_lbl_col'] ?>" maxlength="40" format="*m" emptyok="true" />
<br />
<b><anchor title="<? echo $gm_lang['create'] ?>"><go href="<? echo basename(SELF) ?>?act=create&amp;<? echo strip_tags(SID) ; ?>" method="post">
	<postfield name="label" value="$(label)" /></go><? echo $gm_lang['create'] ?></anchor>
</b>
<br /><br />
<a href='#main'><? echo $gm_lang['cancel'] ?></a><br />
</p>	
<?
	if ($has_labels) {
?>
</card>

<card title="<? echo $gm_lang['remove_label_cap'] ?>" id='remove'>
<onevent type="onenterforward">
	<refresh>
		<setvar name="label" value="-1"/>
	</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

?><br />
<small><b><? echo $gm_lang['note_col'] ?></b> <? echo $gm_lang['lbl_will_not_delete']?></small><br />
<br />
<? echo $gm_lang['remove_label_col'] ?><br />
<select name="label" title="<? echo $gm_lang['remove_label_col'] ?>">
<option value="-1"><? echo $gm_lang['select_label'] ?></option>
<?
	reset($snapshot->label_list);
	foreach ($snapshot->label_list as $indexval => $label_name) {
		echo "<option value=\"".$indexval."\">".cleanse_string($label_name)."</option>\n";
	}
?>
</select>
<br />
<b><anchor title="<? echo $gm_lang['remove'] ?>"><go href="<? echo basename(SELF) ?>?act=remove&amp;<? echo strip_tags(SID); ?>" method="post">
	<postfield name="label" value="$(label)" />
</go><? echo $gm_lang['remove'] ?></anchor>
</b>
<br /><br />
<a href='#main'><? echo $gm_lang['cancel'] ?></a><br />
</p>	
</card>

<card title="<? echo $gm_lang['rename_label_cap'] ?>" id='rename'>
<onevent type="onenterforward">
	<refresh>
		<setvar name="label" value="-1" />
		<setvar name="relabel" value="" />
	</refresh>
</onevent>
<p>
<?
// display a system-wide message
system_message();	

?><br />
<? echo $gm_lang['label_col'] ?><br />
<select name="label" title="<? echo $gm_lang['rename_label_col'] ?>">
<option value="-1"><? echo $gm_lang['select_label'] ?></option>
<?
	reset($snapshot->label_list);
	foreach ($snapshot->label_list as $indexval => $label_name) {
		echo "<option value=\"".$indexval."\">".cleanse_string($label_name)."</option>\n";
	}
?>
</select>
<br />
<? echo $gm_lang['rename_col'] ?><br />
<input name="relabel" title="<? echo $gm_lang['what_call_label'] ?>" maxlength="40" format="*m" emptyok="true" />
<br />
<b><anchor title="<? echo $gm_lang['rename'] ?>"><go href="<? echo basename(SELF)?>?act=rename&amp;<? echo strip_tags(SID); ?>" method="post">
	<postfield name="label" value="$(label)" />
	<postfield name="relabel" value="$(relabel)" />
</go><? echo $gm_lang['rename'] ?></anchor>
</b>
<br /><br />
<a href='#main'><? echo $gm_lang['cancel'] ?></a><br />
</p>	
<?
}
print_footer();


function print_settings_footer() {
	global $set;
	global $gm_lang;

	echo "<a href='setting.php?".RANDOM.GMID."'>".$gm_lang['settings']."</a><br />\n";
	echo "<a href='main.php?sum=1".RANDOM.GMID."'>".$gm_lang['summary']."</a><br />\n";
	echo "<a href='compose.php?action=new&amp;back=label.php".RANDOM.GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
	echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
	echo "</p>\n";
}
?>