<?
/****************************************************************

gmail-mobile (a.k.a. unofficial Gmail Mobile)
Copyright (c) 2005, 2006
Neerav Modi and others

Version 0.11 (c) 2004
GAN Ying Hung, Rudi Pittman, Gaston Annebicque

Licensed under the GNU GPL. For full terms see the file COPYING.

gmail-mobile (unofficial Gmail Mobile since Sept 2004) provides
access to Gmail accounts with any WAP enabled phone or hand held
(in WML format).

http://gmail-mobile.sourceforge.net

*****************************************************************/

require_once("libgmailer.php");
require_once("config.php");

// create the gmail object
$gmailer = new GMailer();
// initialize connection
quick_init($gmailer);

// Connect to gmail
connect_gmail();

// Localization (l10n) phrases
load_language();
																																						 
$search_options	= (isset($_REQUEST['so']) 
				and $_REQUEST['so'] != "") 	? $_REQUEST['so']		: false;
$search		= (isset($_REQUEST['search'])) 	? $_REQUEST['search']	: false;

// simple search
$query		= (isset($_REQUEST['query'])) 	? trim(stripslashes($_REQUEST['query']))	: "";

// advanced search
$from		= (isset($_POST['from'])) 	? trim(stripslashes($_POST['from']))	: "";
$to			= (isset($_POST['to'])) 	? trim(stripslashes($_POST['to']))		: "";
$cc			= (isset($_POST['cc'])) 	? trim(stripslashes($_POST['cc']))		: "";
$bcc		= (isset($_POST['bcc'])) 	? trim(stripslashes($_POST['bcc']))		: "";
$subject	= (isset($_POST['subject']))? trim(stripslashes($_POST['subject']))	: "";
$words		= (isset($_POST['words'])) 	? trim(stripslashes($_POST['words']))	: "";
$nowords	= (isset($_POST['nowords']))? trim(stripslashes($_POST['nowords']))	: "";
$attach		= (isset($_POST['attach'])) ? trim($_POST['attach'])				: false;
$file		= (isset($_POST['file'])) 	? trim(stripslashes($_POST['file']))	: "";
$before		= (isset($_POST['before'])) ? trim($_POST['before'])	: "";
$after		= (isset($_POST['after'])) 	? trim($_POST['after'])		: "";
$flags		= (isset($_POST['flags'])) 	? trim($_POST['flags'])		: "";
$label		= (isset($_POST['label'])) 	? trim($_POST['label'])		: "";

//
// process and do the search
//

if ($search) {
	$error = "";
	
	// advanced search, create the query
	if ($search_options) {
		$query = "";

		if ($words != "") 	$query .= $words. " ";
		if ($nowords != "") $query .= "-(".$nowords. ") ";
		if ($subject != "") $query .= "subject:(".$subject.") ";
		if ($from != "") 	$query .= "from:(".$from.") ";
		if ($to != "") 		$query .= "to:(".$to.") ";
		if ($cc != "") 		$query .= "cc:(".$cc.") ";
		if ($file != "") 	$query .= "filename:(".$file.") ";
		if ($attach) 		$query .= "has:attachment ";
		if ($bcc != "") 	$query .= "bcc:(".$bcc.") ";

		if ($before != "") {
			@list($year,$month,$day) = explode("/",$before);
			if (checkdate($month, $day, $year)) {
				$query .= "before:$before ";
			} else {
				$error .= $gm_lang['before_invalid']."  ";
			}
		}

		if ($after != "") {
			@list($year,$month,$day) = explode("/",$after);
			if (checkdate($month, $day, $year)) {
				$query .= "after:$after ";
			} else {
				$error .= $gm_lang['after_invalid']."  ";
			}
		}

		if ($flags != "") {
			switch($flags) {
				case "all":
					break;
				case -1:
					$error .= $gm_lang['chose_divide_line'];
					$error .= "  ";
					break;
				case "inbox":
					$query .= "in:inbox ";
					break;
				case "star":
					$query .= "is:starred ";
					break;
				case "sent":
					$query .= "from:".$_SESSION['gm_gmail_name']." ";
					break;
				case "draft":
					$query .= "in:drafts ";
					break;
				case "spam":
					$query .= "in:spam ";
					break;
				case "trash":
					$query .= "in:trash ";
					break;
				case "allst":
					$query .= "in:anywhere ";
					break;
				case "read":
					$query .= "is:read ";
					break;
				case "unread":
					$query .= "is:unread ";
					break;
/* 				default: */
/*					$query .= "in:anywhere "; */
/* 					break; */
			}
		}

		if ($label != "") {
			$labels = explode (";",$label);
			if ($labels[0] == "un") {
				$labels = $_SESSION['gm_all_labels'];
				$notlabel = true;
				$query .= "-from:".$_SESSION['gm_gmail_name']." "; 
			} else {
				$notlabel = false;
			}
			foreach ($labels as $indexval => $label_number) {
				if ($notlabel) {
					// unlabeled
					$query .= "-label:".strtolower(str_replace(" ","-",$label_number))." ";
				} elseif (substr($label_number,0,1) == "-") {
					// without label
					$query .= "-label:".strtolower(str_replace(" ","-",$_SESSION['gm_all_labels'][abs((int)$label_number)]))." ";
				} else {
					// with label
					$query .= "label:".strtolower(str_replace(" ","-",$_SESSION['gm_all_labels'][(int)$label_number]))." ";
				}
			}
		}

		// set the advanced search flag
		$so_flag = "&amp;so=1";
	} else {
		// set the advanced search flag
		$so_flag = "";
	}

	// trim and remove double spaces
	$query = str_replace("  "," ",trim($query));
	$error = trim($error);
	// if there is no error, perform the search
	if ($error == "") {
		$_SESSION['gm_search_query'] = $query;
		$_SESSION['gm_last_box'] 	 = "search";
		$_SESSION['gm_last_position']= 0;
		$url = "main.php"."?query=1".$so_flag;
	
		// actual redirection
		redirect_page($url, $gm_lang['search'], $gm_lang['search_created']);	
		
		// MUST exit script after redirecting
		exit();
	}
}

//
// display the search screen
//

if ($search_options) {
	$title = $gm_lang['search_options_cap'];
	$head = $gm_lang['search_options_cap'];
} else {
	$title = $gm_lang['search'];
	$head = $gm_lang['search_mail_cap'];
}

print_headers();			// send wml headers
include("template.php");	// print template

echo "<card title='".$title."' id='main'>\n";
echo "<p align='center'>\n";

// display a system-wide message
system_message();	

if (isset($error) and $error !="") echo "<b>".$gm_lang['errors']." ".$error."</b><br />\n";

?>
<br />
<b><? echo $head; ?></b><br />
</p>
<p>
<br />
<? 
if (!$search_options) { 
?>
	<small><b><? echo $gm_lang['tips'] ?></b><br />
	-&gt; <? echo $gm_lang['tip1'] ?><br />
	-&gt; <? echo $gm_lang['tip2'] ?><br />
	-&gt; <? echo $gm_lang['tip3'] ?><br />
	-&gt; <? echo $gm_lang['tip4'] ?><br />
	</small>
	<br />
	<small>
		<anchor><? echo $gm_lang['clear_search_field'] ?><refresh>
			<setvar name="query" value="" />
		</refresh></anchor>
	</small><br />
	<br />
	<input name="query" format="*m" emptyok="true" />
	<br />
	<b><anchor title="<? echo $gm_lang['search_mail'] ?>"><go href="<? echo basename(SELF); ?>?search=1&amp;<? echo strip_tags(SID) ?>" method="post">
		<postfield name="query" value="$(query)" />
	</go><? echo $gm_lang['search_mail'] ?></anchor>
	</b>
<?
} else {
?>
	<anchor><? echo $gm_lang['clear_search_fields'] ?><refresh>
		<setvar name="from" value="" />
		<setvar name="to" value="" />
		<setvar name="cc" value="" />
		<setvar name="bcc" value="" />
		<setvar name="subject" value="" />
		<setvar name="words" value="" />
		<setvar name="nowords" value="" />
		<setvar name="attach" value="0" />
		<setvar name="file" value="" />
		<setvar name="before" value="" />
		<setvar name="after" value="" />
		<setvar name="label" value="" />
		<setvar name="flags" value="all" />
	</refresh></anchor>
	<br />
	<br />

	<small><b><? echo $gm_lang['tips'] ?></b><br />
	-&gt; <? echo $gm_lang['tip1'] ?><br />
	-&gt; <? echo $gm_lang['tip2'] ?><br />
	-&gt; <? echo $gm_lang['tip3'] ?><br />
	-&gt; <? echo $gm_lang['tip4'] ?></small><br />
	<br />

	<? echo $gm_lang['from'] ?><br />
	<input title="<? echo $gm_lang['from'] ?>" name="from" format="*m" emptyok="true" /><br />
	
	<? echo $gm_lang['to'] ?><br />
	<input title="<? echo $gm_lang['to'] ?>" name="to" format="*m" emptyok="true" /><br />
	
	<? echo $gm_lang['cc'] ?><br />
	<input title="<? echo $gm_lang['cc'] ?>" name="cc" format="*m" emptyok="true" /><br />

	<? echo $gm_lang['bcc'] ?><br />
	<input title="<? echo $gm_lang['bcc'] ?>" name="bcc" format="*m" emptyok="true" />
	<small><? echo $gm_lang['only_on_sent_mail'] ?></small><br />
	<br />

	<? echo $gm_lang['subject'] ?><br />
	<input title="<? echo $gm_lang['subject'] ?>" name="subject" format="*m" emptyok="true" /><br />
	
	<? echo $gm_lang['search_col'] ?><br />
	<select title="<? echo $gm_lang['search_col'] ?>" name="flags">
		<option value="all"><? echo $gm_lang['all_mail'] ?></option>
		<option value="inbox"><? echo $gm_lang['std_box_name'][0] ?></option>
		<option value="star"><? echo $gm_lang['std_box_name'][1] ?></option>
		<option value="sent"><? echo $gm_lang['sent_mail'] ?></option>
		<option value="draft"><? echo $gm_lang['std_box_name'][3] ?></option>
		<option value="spam"><? echo $gm_lang['std_box_name'][5] ?></option>
		<option value="trash"><? echo $gm_lang['std_box_name'][6] ?></option>
		<option value="-1">--------</option>
		<option value="allst"><? echo $gm_lang['std_box_name'][4] ?> &amp; <? echo $gm_lang['std_box_name'][5] ?> &amp; <? echo $gm_lang['std_box_name'][6] ?></option>
		<option value="-1">--------</option>
		<option value="read"><? echo $gm_lang['read_mail'] ?></option>
		<option value="unread"><? echo $gm_lang['unread_mail'] ?></option>
	</select>
	<br />

	<? echo $gm_lang['labels_col'] ?><br />
	<? if (count($_SESSION['gm_all_labels']) > 0) { ?>
	<small><? echo $gm_lang['gmobile_exclusive'] ?></small><br />
	<small>
		<anchor><? echo $gm_lang['clear_labels'] ?><refresh>
			<setvar name="label" value="" />
		</refresh></anchor>
	</small><br />
	<select title="<? echo $gm_lang['labels_col'] ?>" name="label" multiple="true">
	<option value="un">** <? echo $gm_lang['unlabeled'] ?> **</option>
	<optgroup title="<? echo $gm_lang['with_label'] ?>">
		<?
		reset($_SESSION['gm_all_labels']);
		foreach ($_SESSION['gm_all_labels'] as $indexval => $label_name) {
			echo "\t\t<option value=\"".$indexval."\">".cleanse_string($label_name)."</option>\n";
		}
		?>
	</optgroup>
	<optgroup title="<? echo $gm_lang['without_label'] ?>">
		<?
		reset($_SESSION['gm_all_labels']);
		foreach ($_SESSION['gm_all_labels'] as $indexval => $label_name) {
			echo "\t\t<option value=\"-".$indexval."\">".cleanse_string($label_name)."</option>\n";
		}
		?>
	</optgroup>
	</select>
	<br />
	<? } else { ?>
	<small>
	<? echo $gm_lang['have_no_labels'] ?>
	</small><br />
	<? } ?>

	<br />

	<? echo $gm_lang['has_the_words'] ?> <input title="<? echo $gm_lang['has_the_words'] ?>" name="words" format="*m" emptyok="true" /><br />
	
	<? echo $gm_lang['doesnt_have'] ?> <input title="<? echo $gm_lang['doesnt_have'] ?>" name="nowords" format="*m" emptyok="true" /><br />
	
	<? echo $gm_lang['has_attachment_col'] ?><br />
	<select title="<? echo $gm_lang['has_attachment_col'] ?>" name="attach">
		<option value="0"><? echo $gm_lang['doesnt_matter'] ?></option>
		<option value="1"><? echo $gm_lang['has_attachment'] ?></option>
	</select>
	<br />

	<? echo $gm_lang['filename_col'] ?><br />
	<input title="<? echo $gm_lang['filename_col'] ?>" name="file" format="*m" emptyok="true" /><br />

	<? echo $gm_lang['before_date'] ?><br />
	<? echo $gm_lang['as_yyyy_mm_dd'] ?><br />
	<input title="<? echo $gm_lang['before_ymd'] ?>" name="before" format="NNNN\/NN\/NN" emptyok="true" />
	<small><b><? echo $gm_lang['not_inc_date'] ?></b></small><br />
	<br />
	
	<? echo $gm_lang['after_date'] ?><br />
	<? echo $gm_lang['as_yyyy_mm_dd'] ?><br />
	<input title="<? echo $gm_lang['after_ymd'] ?>" name="after" format="NNNN\/NN\/NN" emptyok="true" />
	<small><b><? echo $gm_lang['inc_date'] ?></b></small><br />
	<br />

	<b><anchor title="<? echo $gm_lang['search_mail'] ?>"><go href="<? echo basename(SELF); ?>?search=1&amp;so=1&amp;<? echo strip_tags(SID) ?>" method="post">
		<postfield name="from" value="$(from)" />
		<postfield name="to" value="$(to)" />
		<postfield name="cc" value="$(cc)" />
		<postfield name="bcc" value="$(bcc)" />
		<postfield name="subject" value="$(subject)" />
		<postfield name="words" value="$(words)" />
		<postfield name="nowords" value="$(nowords)" />
		<postfield name="attach" value="$(attach)" />
		<postfield name="file" value="$(file)" />
		<postfield name="label" value="$(label)" />
		<postfield name="flags" value="$(flags)" />
		<postfield name="before" value="$(before)" />
		<postfield name="after" value="$(after)" />
	</go><? echo $gm_lang['search_mail'] ?></anchor>
	</b>
<?
} 
?>
<br />
<br />
	<?

if ($search_options) {
	echo "<a href=\"".basename(SELF)."?so=0".GMID."\">".$gm_lang['hide_search_opts']."</a><br />\n";
} else {
	echo "<a href=\"".basename(SELF)."?so=1".GMID."\">".$gm_lang['show_search_opts']."</a><br />\n";
}
echo "<anchor>".$gm_lang['cancel_search']."<prev/></anchor><br />\n";
echo "<a href='compose.php?action=new&amp;back=search.phpQUESTsoEQUAL$search_options".RANDOM.GMID."'>".$gm_lang['compose_mail']."</a><br />\n";
echo "<a href='main.php?sum=1".RANDOM.GMID."'>".$gm_lang['summary']."</a><br />\n";
echo "<a href='logout.php?".RANDOM.GMID."'>".$gm_lang['sign_out']."</a>\n";
echo "</p>\n";
print_footer();

?>